=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub DeletePost{
my (%Forum, %Post, %Message, $Template, $Temp, $PostTimeClass, $PostTimeFormat);

	$Plugins{Bar_Action} = $Language{bar_delete_post};

	%Forum = &GetForum($Param{Forum});

	%Post = &GetForumPost($Param{Post});
	%Message = &GetForumMessage($Param{Post});
	#------------------------------------------------------
	if (!&CheckPostActionPermissions("Deletes", %Post)) {
				$Plugins{Body} = $Language{error_delete_post_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{General_Template});
				return;
	}
	#------------------------------------------------------
	$Template = &Translate_File($Global{ForumDeletePost_Template});
	$Template =~ s/<!--Action-->/$Script_URL/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Post{Forum}/g;
	$Template =~ s/<!--Topic-->/$Post{Topic}/g;
	$Template =~ s/<!--Post-->/$Param{Post}/g;
	$Template =~ s/<!--Author-->/$Post{Author}/g;
	
	$Temp = qq!$Script_URL?action=ViewProfile&Author=$Post{Author}&Lang=$Global{Language}!;
	$Template =~ s/<!--AuthorLink-->/$Temp/g;
	#------------------------------------------------------
	$Temp = qq!$Script_URL?action=TopicReview&Topic=$Param{Topic}&Page=1&Lang=$Global{Language}!;
	$Template =~ s/<!--TopicReviewLink-->/$Temp/g;
	#------------------------------------------------------
	$PostTimeClass = ""; $PostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Template =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
				$PostTimeClass = $1 . $2 . $3. $4. $5;
				$PostTimeFormat =  $4;
	}
	$PostTimeClass =~ s/\(/\\\(/g;
	$PostTimeClass =~ s/\)/\\\)/g;

	if ($Post{Time} > 0) {
			$Temp = &ParseDate($PostTimeFormat, $Post{Time});
	}
	else{	
			$Temp = "";
	}
	$Template =~ s/$PostTimeClass/$Temp/g;
	#------------------------------------------------------
	$Template =~ s/<!--Subject-->/$Message{Subject}/g;
	
	$Temp = $Message{Message};
	$Temp =~ s/\\\n/\n/g;
	$Temp =~ s/[\>]\s*\n/\> /g;
	$Temp =~ s/\n/\<br\>/g;
	$Template =~ s/<!--Message-->/$Temp/g;

	&Display($Template, 1);
}
#==========================================================
sub ProcessDeletePost{
my (%Post, %Message, $Posts, %LastPost);

	%Post = &GetForumPost($Param{Post});
	$Param{Topic} = $Post{Topic};
	$Param{Forum} = $Post{Forum};

	if ($Param{CancelDelete}) {
			&ViewTopic;
			return;
	}
	
	if (!&CheckPostActionPermissions("Deletes", %Post)) {
				$Plugins{Body} = $Language{error_delete_post_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{General_Template});
				return;
	}

	&DeleteForumPost($Param{Post});

	@Posts = &GetForumTopicPosts($Param{Topic});
	$Posts = @Posts;
	if (!$Posts) {
			&DeleteForumTopic($Param{Topic});
	}
	else{
			%LastPost = &GetTopicLastPost($Param{Topic});
			$Query = qq!UPDATE Forum_Topics SET Updated=$LastPost{Time}, LastPost=$LastPost{Post}, Replies=($Posts-1) WHERE Topic=$Param{Topic}!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	&UpdateForumsCounts;
	#------------------------------------------------------
	if ($Posts) {
			&ViewTopic;
	}
	else{
			&Forums;
	}
	#------------------------------------------------------
}
#==========================================================
1;