=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Create_Forum_SQL_Tables{
my ($Help, $Out);

	$Help = &Help_Link("Setup_Wizard");

	$Out = qq!<P align="center"><font SIZE="4"><b>Creating Forum Tables</b></font></P>!;
	$Out .= &Create_Forum_Tables;

	&Print_Page($Out, "Setup Wizard", $Help);	
	
}
#==========================================================
sub Create_Forum_Tables{
my($Out, $INT, $TEXT);

	if ($Global{DB_Driver} eq "Informix") { 
				  $TEXT = "CHAR(5000)";
				  $INT = "INTEGER";   
	}
	elsif ($Global{DB_Driver} eq "InterBase") { 
				  $TEXT = "VARCHAR(5000)";
				  $INT = "INT";
	}
	elsif ($Global{DB_Driver} eq "Oracle") { 
				  $TEXT = "VARCHAR(5000)";
				  $INT = "NUMBER";    
	} 
	else {
				  $TEXT = "TEXT";
				  $INT = "INT";
	}

	$Out = "";


	$Out .= &Create_Community_Posts_Table($INT, $TEXT);
	$Out .= &Create_Community_Boads_Table($INT, $TEXT);
	$Out .= &Create_Forum_Users_Info_Table($INT, $TEXT);
	
	$Out .= &Create_Forum_Topic_Notify_Table($INT, $TEXT);
	$Out .= &Create_Forum_Config_Table($INT, $TEXT);
	$Out .= &Create_Forum_Notify_Table($INT, $TEXT);
	$Out .= &Create_Forum_PrivMsgs_Table($INT, $TEXT);
	$Out .= &Create_Forum_User_Groups_Table($INT, $TEXT);

	$Out .= &Create_Forum_Groups_Table($INT, $TEXT);
	$Out .= &Create_Forum_Moderators_Table($INT, $TEXT);
	$Out .= &Create_Forum_Watching_Table($INT, $TEXT);
	$Out .= &Create_Forum_Forums_Table($INT, $TEXT);
	$Out .= &Create_Forum_Topics_Table($INT, $TEXT);
	$Out .= &Create_Forum_Posts_Table($INT, $TEXT);
	$Out .= &Create_Forum_Messages_Table($INT, $TEXT);
	$Out .= &Create_Forum_Media_Table($INT, $TEXT);
	$Out .= &Create_Forum_Read_Table($INT, $TEXT);
	$Out .= &Create_Forum_Search_Table($INT, $TEXT);
	$Out .= &Create_Forum_Block_List_Table($INT, $TEXT);
	$Out .= &Create_Transactions_Table($INT, $TEXT);
	$Out .= &Create_Deposits_Table($INT, $TEXT);
	$Out .= &Create_Forum_Whos_Online_Table($INT, $TEXT);

	$Out .= &Create_Users_Table($INT, $TEXT);
	$Out .= &Create_Pending_Users_Table($INT, $TEXT);
	$Out .= &Create_Users_Info_Table($INT, $TEXT);
	$Out .= &Create_Banner_Tables($INT, $TEXT);

	return $Out;
}
#==========================================================
sub Create_Users_Table{
my ($INT, $TEXT) = @_;
my ($Table, $Out);

	$Table = qq!CREATE TABLE Users (
							User_ID VARCHAR(250),
							Password VARCHAR(100),
							Email VARCHAR(200),
							FName VARCHAR(100),
							LName VARCHAR(100),
							Company VARCHAR(200),
							Job_Title VARCHAR(200),
							Street VARCHAR(200),
							City VARCHAR(100),
							State VARCHAR(100),
							Zip VARCHAR(100),
							Country VARCHAR(200),
							Phone VARCHAR(100),
							Mobile VARCHAR(100),
							Fax VARCHAR(100),
							Website VARCHAR(200),
							Payment_Method VARCHAR(20),
							Start_Date VARCHAR(10),
							Last_Updated VARCHAR(10),
							Status  VARCHAR(3),
							User_Icon VARCHAR(200),
							Total_Paid DECIMAL(15,5),
							Current_Balance DECIMAL(15,5),
							Last_Paid_Date VARCHAR(10),
							User1 VARCHAR(250),
							User2 VARCHAR(250),
							User3 VARCHAR(250),
							User4 VARCHAR(250),
							User5 VARCHAR(250),
							User6 VARCHAR(250),
							User7 VARCHAR(250),
							User8 VARCHAR(250),
							User9 VARCHAR(250),
							User10 VARCHAR(250),
							User11 VARCHAR(250),
							User12 VARCHAR(250),
							User13 VARCHAR(250),
							User14 VARCHAR(250),
							User15 VARCHAR(250),
							User16 VARCHAR(250),
							User17 VARCHAR(250),
							User18 VARCHAR(250),
							User19 VARCHAR(250),
							User20 VARCHAR(250)
					)!;

	$Out = &CreateTable("Users", $Table);
  
   $Table = qq!CREATE UNIQUE INDEX Users_idx1 on Users(User_ID)!;
	$Out .= &CreateTable("Users Index", $Table);

	return $Out;
}				
#==========================================================
sub Create_Pending_Users_Table{
my ($INT, $TEXT) = @_;
my ($Table, $Out);

	$Table = qq!CREATE TABLE Pending_Users (
							User_ID VARCHAR(250),
							Password VARCHAR(100),
							Email VARCHAR(200),
							FName VARCHAR(200),
							LName VARCHAR(200),
							Company VARCHAR(200),
							Job_Title VARCHAR(200),
							Street VARCHAR(200),
							City VARCHAR(100),
							State VARCHAR(100),
							Zip VARCHAR(100),
							Country VARCHAR(200),
							Phone VARCHAR(50),
							Mobile VARCHAR(50),
							Fax VARCHAR(50),
							Website VARCHAR(200),
							Payment_Method VARCHAR(20),
							CC_Number VARCHAR(20),
							CC_Name VARCHAR(70),
							CC_Type VARCHAR(40),
							CC_Month $INT,
							CC_Year $INT,
							CC_CVV VARCHAR(10),
							CC_IssueNum VARCHAR(30),
							CC_Bank VARCHAR(200),
							CC_Phone VARCHAR(50),
							CC_Street VARCHAR(200),
							CC_City VARCHAR(200),
							CC_State VARCHAR(100),
							CC_Zip VARCHAR(100),
							CC_Country VARCHAR(100),
							Start_Date VARCHAR(10),
							Last_Updated VARCHAR(10),
							Status  VARCHAR(3),
							User_Icon VARCHAR(200),
							Total_Paid DECIMAL(15,5),
							Current_Balance DECIMAL(15,5),
							Last_Paid_Date VARCHAR(10),
							Promotional_Code VARCHAR(100),
							Confirmation_Code VARCHAR(100),
							User1 VARCHAR(250),
							User2 VARCHAR(250),
							User3 VARCHAR(250),
							User4 VARCHAR(250),
							User5 VARCHAR(250),
							User6 VARCHAR(250),
							User7 VARCHAR(250),
							User8 VARCHAR(250),
							User9 VARCHAR(250),
							User10 VARCHAR(250),
							User11 VARCHAR(250),
							User12 VARCHAR(250),
							User13 VARCHAR(250),
							User14 VARCHAR(250),
							User15 VARCHAR(250),
							User16 VARCHAR(250),
							User17 VARCHAR(250),
							User18 VARCHAR(250),
							User19 VARCHAR(250),
							User20 VARCHAR(250)
					)!;
	$Out = &CreateTable("Pending Users", $Table);
   
   $Table = qq!CREATE UNIQUE INDEX Pending_Users_idx1 on Pending_Users(User_ID)!;
	$Out .= &CreateTable("Pending Users Index", $Table);
	return $Out;
}				
#==========================================================
sub Create_Users_Info_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Users_Info (
							User_ID CHAR(50),
							Sell CHAR(1),
							Buy CHAR(1),
							Verified CHAR(1), 
							Verified1 CHAR(1), 
							Verified2 CHAR(1), 
							Partner CHAR(1), 
							Sponser CHAR(1), 
							Power CHAR(1), 
							Rated  $INT
					)!;

	return &CreateTable("Users_Info", $Table);
}				
#==========================================================
sub Create_Forum_Forums_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Forums (
							Forum $INT,
							Parent $INT,
							Name VARCHAR(250),
							Description $TEXT,
							
							Sort $INT,
							Active $INT,
							Accept $INT,
							Status $INT,

							View $INT,
							Browse $INT,
							Reads $INT,
							Post $INT,
							Reply $INT,
							Edit $INT,
							Deletes $INT,
							Announce $INT,
							Sticky $INT,
							Poll $INT, # Poll create
							Vote $INT, # Allow Thread Voting?
							Attach $INT,
							ViewIP $INT,

							LastPost $INT,

							Posts $INT,
							Topics $INT,
							
							SubPosts $INT,
							SubTopics $INT,

							Icon VARCHAR(100),
							Redirect VARCHAR(250), #Redirect Board to URL

							Template VARCHAR(250),

							Meta_Title  VARCHAR(250),
							Meta_Description $TEXT,
							Meta_Keywords $TEXT,

							Zone1 $TEXT, # text to be displayed on this forum only
							Zone2 $TEXT, # text to be displayed on this forum only
							Zone3 $TEXT, # text to be displayed on this forum only
							Zone4 $TEXT # text to be displayed on this forum only
					)!;

	return &CreateTable("Forum Forums", $Table);
}				
#==========================================================
sub Create_Forum_Topics_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Topics (
							Topic $INT,
							Forum $INT,

							Title VARCHAR(250),
							Author VARCHAR(50),
							Time $INT,
							Updated $INT,

							Views $INT,
							Replies $INT,

							Status $INT, # Open , Closed
							Type $INT, # Normal, Sticky, Announcement
							Poll $INT, # Poll

							FirstPost $INT,
							LastPost $INT
						)!;

	return &CreateTable("Forum Topics", $Table);
}
#==========================================================
sub Create_Forum_Posts_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Posts (
							Post $INT,
							Topic $INT,
							Forum $INT,
							Time $INT,
							Updated $INT, # Last updated time
							Author VARCHAR(50),
							Username VARCHAR(50), # post username, PIN
							Notify $INT, #Notify poster when a reply is posted
							IP VARCHAR(250)
						)!;

	return &CreateTable("Forum Posts", $Table);
}
#==========================================================
sub Create_Forum_Messages_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Messages (
							Post $INT,
							Forum $INT,
							Subject VARCHAR(250),
							Message $TEXT
						)!;

	return &CreateTable("Forum Messages", $Table);
}
#==========================================================
sub Create_Forum_Media_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Media (
							Post $INT,
							Color VARCHAR(10),
							Icon VARCHAR(50),
							Media_Show $INT,
							Media $TEXT
						)!;

	return &CreateTable("Forum Media", $Table);
}
#==========================================================
sub Create_Forum_Search_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Search (
							Cash $INT,
							Time $INT,
							Forums  $TEXT,
							Terms VARCHAR(250),
							Authors VARCHAR(250),
							AuthorsFilter VARCHAR(250),
							Mode $INT, # display mode, 1=topics, 0=posts
							Period DECIMAL(15,2),  # Search previous days
							TitlesOnly $INT,  # search title only
							Result $TEXT
						)!;

	return &CreateTable("Forum Search", $Table);
}
#==========================================================
sub Create_Forum_Read_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Topic_Read (
							Topic $INT,
							User VARCHAR(50)
						)!;

	return &CreateTable("Forum Topic Read", $Table);
}
#==========================================================
sub Create_Forum_Groups_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Groups (
									GroupID $INT,
									Name VARCHAR(250),
									Status $INT,
									Description $TEXT,
									Moderators $TEXT,

									Level $INT, # 0=user, 1=admin, 2=mod
									
									View $INT,
									Browse $INT,
									Reads $INT,
									Post $INT,
									Reply $INT,
									Edit $INT,
									Deletes $INT,
									Announce $INT,
									Sticky $INT,
									Poll $INT,
									Vote $INT,
									Attach $INT,
									ViewIP $INT,
									
									Icon VARCHAR(100),
									
									Meta_Title  VARCHAR(250),
									Meta_Description $TEXT,
									Meta_Keywords $TEXT,
									
									Zone1 $TEXT,
									Zone2 $TEXT,
									Zone3 $TEXT,
									Zone4 $TEXT
							)!;

	return &CreateTable("Forum Groups", $Table);
}				
#==========================================================
sub Create_Forum_User_Groups_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_User_Groups (
									User VARCHAR(250),
									GroupID $INT
							)!;

	return &CreateTable("Forum User Groups", $Table);
}				
#==========================================================
sub Create_Forum_Users_Info_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Users_Info (
							User_ID VARCHAR(250),
							LastVist $INT,
							Level $INT, # 0=User, 1=Admin, 2=Mod
							Posts $INT,
							Timezone DECIMAL(3,2),
							Language VARCHAR(250),
							DateFormat VARCHAR(250),
							EmailTime $INT,
							ViewEmail $INT,
							AttachSign $INT,
							AllowPM $INT,
							ViewOnline $INT,
							NotifyPM $INT,
							Rank DECIMAL(5,2),
							Avatar VARCHAR(250),
							Location VARCHAR(250),
							WebTitle VARCHAR(250),
							WebURL VARCHAR(250),
							Sig $TEXT,

							ICQ VARCHAR(250),
							AIM VARCHAR(250),
							YIM VARCHAR(250),
							MSNM VARCHAR(250),
							Occupation VARCHAR(250),
							Interests $TEXT,

							View $INT,
							Browse $INT,
							Reads $INT,
							Post $INT,
							Reply $INT,
							Edit $INT,
							Deletes $INT,
							Announce $INT,
							Sticky $INT,
							Poll $INT,
							Vote $INT,
							Attach $INT,
							ViewIP $INT,

							Custom1 VARCHAR(250),
							Custom2 VARCHAR(250),
							Custom3 VARCHAR(250),
							Custom4 VARCHAR(250),
							Custom5 VARCHAR(250),
							Custom6 VARCHAR(250),
							Custom7 VARCHAR(250),
							Custom8 VARCHAR(250),
							Custom9 VARCHAR(250),
							Custom10 VARCHAR(250)
						)!;

	return &CreateTable("Forum Users Info", $Table);
}
#==========================================================
sub Create_Forum_Watching_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Watching (
							User VARCHAR(250),
							Topic $INT
						)!;

	return &CreateTable("Forum Watching", $Table);
}
#==========================================================
sub Create_Forum_Topic_Notify_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Topic_Notify (
							User VARCHAR(250),
							Topic $INT,
							Status $INT
						)!;

	return &CreateTable("Forum Topic Notify", $Table);
}
#==========================================================
sub Create_Forum_Notify_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Notify (
							User VARCHAR(250),
							Forum $INT
						)!;

	return &CreateTable("Forum Notify", $Table);
}
#==========================================================
sub Create_Forum_Config_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Config (
							Name VARCHAR(250),
							Value VARCHAR(250)
						)!;

	return &CreateTable("Forum Config", $Table);
}
#==========================================================
sub Create_Forum_Moderators_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Moderators (
							User VARCHAR(250),
							Forum $INT
						)!;

	return &CreateTable("Forum Moderators", $Table);
}
#==========================================================
sub Create_Forum_PrivMsgs_Table{
my ($INT, $TEXT) = @_;
my ($Table, $Out);

	$Table = qq!CREATE TABLE Forum_PrivMsgs (
							ID $INT,
							Folder $INT,
							User VARCHAR(250),
							FromUser VARCHAR(250),
							ToUser VARCHAR(250),
							Subject VARCHAR(250),
							Date $INT,
							Status $INT, # read, unread
							Priority $INT, # high, normal, low
							Attach $INT, # has attachements
							IP VARCHAR(250)
						)!;

	$Out = &CreateTable("Forum Private Messages", $Table);

	$Table = qq!CREATE TABLE Forum_PrivMsgsBody (
							ID $INT,
							Folder $INT,
							User VARCHAR(250),
							FromUser VARCHAR(250),
							ToUser VARCHAR(250),
							Date $INT,
							Priority $INT, # high, normal, low
							Attach $INT, # has attachements
							Media $TEXT,
							Subject VARCHAR(250),
							Message $TEXT
						)!;

	$Out .= &CreateTable("Forum Private Messages Body", $Table);

	return $Out;
}
#==========================================================
#==========================================================
sub Create_Banner_Tables{
my ($INT, $TEXT) = @_;
my ($Table, $Out);

	$Table = qq!CREATE TABLE Banner_Accounts (
							Account CHAR(50),
							Password CHAR(20),
							Email CHAR(100),
							Name CHAR(20),
							Company CHAR(50),
							Street CHAR(80),
							City CHAR(40),
							State CHAR(12),
							Zip CHAR(12),
							Country CHAR(20),
							Phone CHAR(20),
							Fax CHAR(20),
							Status $INT,
							Start_Date CHAR(10),
							Comments $TEXT
					)!;

	$Out = &CreateTable("Banner Accounts", $Table);

   $Table = qq!CREATE UNIQUE INDEX Banner_Accounts_idx on Banner_Accounts(Account)!;
	$Out .= &CreateTable("Banner Accounts Index", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE  Banner_Campaigns (
							Account CHAR(50),
							Campaign CHAR(100),
							Target_Tag CHAR(10),
							Redirect_URL CHAR(255),
							Under_Text CHAR(255),
							ALT_Text CHAR(255),
							Banner_URL CHAR(255), 
							Text_Banner $TEXT,
							Width $INT,
							Height $INT,
							Type CHAR(50),
							Clicks $INT,
							Max_Clicks $INT,
							Impressions $INT,
							Max_Impressions $INT,
							Start_Date $INT, 
							End_Date $INT,
							Status $INT
					)!;
	$Out .= &CreateTable("Banner Campaigns", $Table);

   $Table = qq!CREATE UNIQUE INDEX Banner_Campaigns_idx on Banner_Campaigns(Campaign)!;
	$Out .= &CreateTable("Banner Campaigns index ", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE  Banner_Zones (
							Zone CHAR(50),
							Default_Zone CHAR(50),
							Default_Campaign CHAR(100)
					)!;

	$Out .= &CreateTable("Banner Zones", $Table);

   $Table = qq!CREATE UNIQUE INDEX Banner_Zones_idx on Banner_Zones(Zone)!;
	$Out .= &CreateTable("Banner Zones Index", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE  Banners (
							Campaign CHAR(100),
							Zone CHAR(50),
							Status $INT
					)!;
	$Out .= &CreateTable("Banners", $Table);

   $Table = qq!CREATE INDEX Banners_idx on Banners(Campaign, Zone)!;
	$Out .= &CreateTable("Banners Index", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE  Banner_Rotation_Index (
							Zone CHAR(50),
							Zone_Index $INT
					)!;
	$Out .= &CreateTable("Banner Rotation Index", $Table);

   $Table = qq!CREATE INDEX Banner_Rotation_idx on Banner_Rotation_Index(Zone)!;
	$Out .= &CreateTable("Banner Rotation index", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE Banner_Daily_Stats (
							Campaign CHAR(100),
							Clicks $INT,
							Impressions $INT,
							Date CHAR(15)
					)!;
	$Out .= &CreateTable("Banner Daily Stats", $Table);

   $Table = qq!CREATE INDEX Banner_Daily_Stats_idx on Banner_Daily_Stats(Campaign)!;
	$Out .= &CreateTable("Banner Daily Stats index", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE Banner_Hourly_Stats (
							Campaign CHAR(100),
							Clicks $INT,
							Impressions $INT,
							Hour CHAR(15)
					)!;
	$Out .= &CreateTable("Banner Hourly Stats", $Table);

   $Table = qq!CREATE INDEX Banner_Hourly_Stats_idx on Banner_Hourly_Stats(Campaign)!;
	$Out .= &CreateTable("Banner Hourly Stats index", $Table);
	#------------------------------------------------------
	$Table = qq!CREATE TABLE Banner_Click_Log (
							Campaign CHAR(100),
							Remote CHAR(25),
							Refer CHAR(125),
							Agent CHAR(100),
							Date CHAR(15),
							Time CHAR(8),
							Action $INT
					)!;
	$Out .= &CreateTable("Banner Click Log", $Table);

   $Table = qq!CREATE INDEX Banner_Click_Log_idx on Banner_Click_Log(Campaign)!;
	$Out .= &CreateTable("Banner Click Log index", $Table);

	return $Out;
}				
#==========================================================
sub Create_Forum_Whos_Online_Table{
my ($INT, $TEXT) = @_;
my ($Table);

$Table = qq!CREATE TABLE Forum_Whos_Online (
							IP CHAR(30),
							User_ID CHAR(50), 
							Time $INT
				)!;
	
	return &CreateTable("Forum Who\'s Online", $Table);
}
#==========================================================
sub Create_Deposits_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Deposits (
								User_ID CHAR(50),
								Amount DECIMAL(15,2),
								Deposit_Date $INT,
								Source CHAR(50)
							)!;

	return &CreateTable("Deposits", $Table);
}
#==========================================================
sub Create_Transactions_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Transactions (
										TID CHAR(25),
										User_ID CHAR(50),
										ID $INT,
										Type $INT,
										Amount DECIMAL(9,5),
										Due DECIMAL(9,5),
										Balance DECIMAL(15,5),
										Date $INT,
										Comments CHAR(80)
							)!;

	return &CreateTable("Transactions", $Table);
}
#==========================================================
sub Create_Forum_Block_List_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_Block_List (
											User_ID CHAR(50),
											Blocked_ID CHAR(50)
							)!;
	return &CreateTable("Block List", $Table);
}
#==========================================================
sub CreateTable{
my ($Name, $Code) = @_;

   if ($dbh->do($Code)) {
			return (" $Name Table Successfully Created.<br>\n");
	}
   else {
			return (" Error Creating $Name Table: $DBI::errstr.<br>\n");
   }
}
#==========================================================
sub Create_Community_Boads_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_CommunityBoards (
							Board $INT,
							Name VARCHAR(250),
							Description $TEXT,
							
							Sort $INT,
							Posts $INT,
							Icon VARCHAR(100),
							Template VARCHAR(250),

							Meta_Title  VARCHAR(250),
							Meta_Description $TEXT,
							Meta_Keywords $TEXT,

							Zone1 $TEXT, # text to be displayed on this forum only
							Zone2 $TEXT, # text to be displayed on this forum only
							Zone3 $TEXT, # text to be displayed on this forum only
							Zone4 $TEXT # text to be displayed on this forum only
					)!;

	return &CreateTable("Forum CommunityBoards", $Table);
}				
#==========================================================
sub Create_Community_Posts_Table{
my ($INT, $TEXT) = @_;
my ($Table);

	$Table = qq!CREATE TABLE Forum_CommunityPosts (
							Board $INT,
							Post $INT,
							Message $TEXT,
							User_ID VARCHAR(250),
							Date $INT,
							Bold CHAR(1),
							Italic CHAR(1),
							Color VARCHAR(100),
							IP VARCHAR(250)
			)!;

	return &CreateTable("Forum CommunityPosts", $Table);
}				
#==========================================================


1;
