=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Check_Referer{
	$Check=&Check_Referers;
	if ($Check == 0) {
		print "Content-type: text/html\n\n";
		&Msg($Language{referer_error_title}, $Language{referer_error_msg}, 1);
		exit 0;
	}
}
#==========================================================
sub Get_Languages{
my (@Languages);

	$Global{Languages} ||= "English";
	@Languages=split(/\|/, $Global{Languages});
	return @Languages;
}
#==========================================================
sub Prepare_Language_List{
my(@Files, $file, $Langs);
my(%Config);

	undef @Files;
	opendir(Dir, "$Global{Language_Dir}");
	foreach $File (readdir(Dir)) {
			push (@Files, "$File");
    }

	closedir(Dir);

	@Files =sort @Files;
	
	$Langs = "";
	foreach $File(@Files) {
		if (-d "$Global{Language_Dir}/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
					$Langs .= "|$File";
		}
 
	}
	$Langs =~ s/^\|//g;
	
	undef %Config;
	$Config{Languages} = $Langs;
	&Update_Configuration(%Config);
}
#==========================================================
sub Access_Lock_Status{
my ($Format);

	if ($Global{Access_Lock_Status} == 0) {
		return 0;
	}
	else{
		&Read_Language_File($Global{Language_Access_Lock_File});
		print "Content-Type: text/html\n\n";
		print  $Language{access_lock_header};
		print  $Language{access_lock_title};
		print  $Language{access_lock_description};
		$Format = $Language{access_lock_time};
		#------------------------------------------------------
		$PostTimeClass = ""; $PostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
		if ($Format =~ m/(<!--)(Time)(:\()([^\)]+)(\)-->)/){
					$PostTimeClass = $1 . $2 . $3. $4. $5;
					$PostTimeFormat =  $4;
		}
		$PostTimeClass =~ s/\(/\\\(/g;
		$PostTimeClass =~ s/\)/\\\)/g;
		#------------------------------------------------------
		#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
		$Temp = &ParseDate($PostTimeFormat, &Time(time));
		$Format =~ s/$PostTimeClass/$Temp/g;
		print "$Format";
		#------------------------------------------------------
		print  $Language{access_lock_signature};
		exit 0;
	}
	
}
#==========================================================
sub Exit{
my($Msg, $Title, $Level)=@_;
my ($Out);

	if ($Title eq "") {$Title="Error";	}
	$Out = &Error($Msg, $Title, $Level);
	print "Content-type: text/html\n\n";
	print "$Out";
	if ($dbh) {
			&DB_Disconnect();
	}
	exit 0;
}
#==========================================================
sub Quit{

	if ($dbh) {
			&DB_Disconnect();
	}
	exit 0;
}
#==========================================================
sub Rating_Stars_Image{
my($Rating) = @_;
my(@Stars, $Star, $From, $To, $Image);

	@Stars = split (/\|/, $Language{feedback_stars});

	foreach $Star (@Stars) {
			($From, $To, $Image) = split(/\:/, $Star);
			if ($Rating >= $From && $Rating <= $To) {
				return $Image;
			}
	}
	return "";
}
#==========================================================
sub Read_Language_File{
my($Filename) = shift;
my(@Variables, $Line);
my($Key, $Value);

	open(FILE, "$Filename") || &Exit("Error: Can't open language file $Filename: $!" ."<br>Line ". __LINE__ . ", File ". __FILE__);
	@Variables = <FILE>;
	close(FILE);
	
	foreach $Line (@Variables) {
		chomp($Line);
		($Key, $Value) = split ("~==~", $Line);
#		$Value =~ s/\'/\&\#39\;/g;
		$Language{$Key}="$Value";
	}

}
#==========================================================
sub Get_Language_File{ 
my ($Filename) = shift;
my (%Langs, @Variables, $Line);
my ($Key, $Value);

	open(FILE, "$Filename") || &Exit("Error: Can't open language file $Filename: $!" ."<br>Line ". __LINE__ . ", File ". __FILE__);
	@Variables = <FILE>;
	close(FILE);
	
	foreach $Line (@Variables) {
		chomp($Line);
		($Key, $Value) = split("~==~", $Line);
		$Value =~ s/\'/\&\#39\;/g;
		$Langs{$Key}="$Value";
	}

	return  %Langs;
}
#==========================================================
sub Sign_Out{

	if ($Global{MewsoftPassport}) {
			&Delete_Cookies("MewsoftPassport_User", "MewsoftPassport_Password", "MewsoftPassport_Session");
			$Cookies{MewsoftPassport_User} = "";
			$Cookies{MewsoftPassport_Password}  = "";
			$Cookies{MewsoftPassport_Session} = "";
	}
	else{
			&Delete_Cookies("Boardawy_User", "Boardawy_Password", "Boardawy_Session");
			$Cookies{Boardawy_User} = "";
			$Cookies{Boardawy_Password}  = "";
			$Cookies{Boardawy_Session} = "";
	}

	$Param{User_ID} = "";
	$Param{Password} = "";

	&Account_Login;
}
#==========================================================
sub Account_Login{
my ($URL);

	if ($Global{SSL_Status}){
			$URL = "$Global{SSL_URL}/$Global{Main_Prog}";
	}
	else{
			$URL = "$Global{CGI_URL}/$Global{Main_Prog}";
	}

	print "Location: $URL?action=Account_Manager_Login&Lang=$Global{Language}\n\n";
}
#==========================================================
sub Check_Account_Login{

	if (!&Check_Previous_User_Login) {
			&Account_Login;
			&Quit;
	}
}
#==========================================================
sub Check_Previous_User_Login{
my (%User);

	$Param{User_ID} = "";
	$Param{Password} = "";
	$Param{Boardawy_Session} = "";
	$Param{MewsoftPassport_Session} = "";

	if ($Global{MewsoftPassport}) {
			if ($Cookies{MewsoftPassport_User} && $Cookies{MewsoftPassport_Password} ){
						%User = &Get_User_By_Login($Cookies{MewsoftPassport_User}, $Cookies{MewsoftPassport_Password});
						if (%User && $User{Status}) {
								$Param{User_ID} = lc($Cookies{MewsoftPassport_User});
								$Param{Password} = $Cookies{MewsoftPassport_Password};
								$Param{MewsoftPassport_Session} = $Cookies{MewsoftPassport_Session};
								return 1;
						}
			}
	}
	else{
			if ($Cookies{Boardawy_User} && $Cookies{Boardawy_Password} ){
						%User = &Get_User_By_Login($Cookies{Boardawy_User}, $Cookies{Boardawy_Password});
						if (%User && $User{Status}) {
								$Param{User_ID} = lc($Cookies{Boardawy_User});
								$Param{Password} = $Cookies{Boardawy_Password};
								$Param{Boardawy_Session} = $Cookies{Boardawy_Session};
								return 1;
						}
			}
	}

	return 0;
}
#==========================================================
sub Get_File{
my ($File)=shift;
my (@Temp, $Out);

	open(IN, "$File") || &Exit("Error, Can't open file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
    @Temp = <IN>;
    close(IN);

	$Out = join("", @Temp);
	return $Out;
}
#==========================================================
sub Check_User_Exist{
my ($User_ID) = shift;
my ($Query, $sth, $Found, $Temp);

	$User_ID = $dbh->quote($User_ID);
	$Query = qq!SELECT User_ID FROM Users WHERE User_ID = $User_ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while (($Temp) = $sth->fetchrow_array){$Found = 1; last;}
	$sth->finish;
	return $Found;
}
#==========================================================
sub Check_Email_Exist{
my ($Email) = @_;
my ($Query, $sth, $Found, $Temp);

	$Email = $dbh->quote($Email);
	$Query = qq!SELECT Email FROM Users WHERE Email=$Email!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while (($Temp) = $sth->fetchrow_array){$Found = 1; last;}
	$sth->finish;
	return $Found;
}
#==========================================================
sub Check_User_Authentication{
my ($User_ID, $Password) = @_;
my (%User);
		
	%User = &Get_User_By_Login($User_ID, $Password);
	if (%User) {
		if ($User{Status} && ($User{User_ID} eq $User_ID) && ($User{Password} eq $Password)) {return 1;}
	}
	return 0;
}
#==========================================================
sub Whos_Online{
my ($IP, $TimeOut, $Time, $Query, $sth, $User_ID, $Visitors, $Users, @Row);

	$IP = $ENV{REMOTE_ADDR};
	$IP = $dbh->quote($IP);

	$TimeOut = time - $Global{Whos_Online_Time_Out};

	$Query = qq!DELETE FROM Forum_Whos_Online WHERE Time < $TimeOut!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Forum_Whos_Online WHERE IP=$IP!;
	$sth = $dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Time = time;
	$Param{User_ID} ||= "";
	$User_ID =	$dbh->quote($Param{User_ID});

	if ($User_ID) {
			$Query = qq!DELETE FROM Forum_Whos_Online WHERE User_ID=$User_ID!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	$Query = qq!INSERT INTO Forum_Whos_Online VALUES($IP, $User_ID, $Time)!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!SELECT IP, User_ID FROM Forum_Whos_Online WHERE Time>=$TimeOut!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth ->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	
	$Visitors = 0; $Users = 0;

	while (@Row = $sth->fetchrow_array) {
			if ($Row[0]) {$Visitors ++;}
			if ($Row[1]) {$Users ++;}
	}
	$sth->finish;
	$Guests = $Visitors - $Users;
	if ($Guests < 0) {$Guests = 0;}

	$Plugins{Online_Total} =  $Visitors;
	$Plugins{Online_Users} = $Users;
	$Plugins{Online_Guests} = $Guests;

	return ($Visitors, $Users,  $Guests);
}
#==========================================================
sub Check_SSL_Graphics{

	if ($Global{SSL_Status}){
		$Global{Images_URL} = $Global{Images_URL_SSL};	
	}

}
#==========================================================
sub ReadThemeConfig{
my (@Temp, %Classes, $Line, $K, $V);

	open(FILE, "$Global{ThemeConfigFile}") || &Exit("Error, Can't open file $Global{ThemeConfigFile}: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
    @Temp = <FILE>;
    close(FILE);
	
	undef %Classes;

	foreach $Line (@Temp) {
			$Line =~ s/\n$//;
			if (!$Line) {next;}
			($K, $V) = split(/\~\=\=\~/, $Line);
			if (!$K) {next;}
			$V =~ s/\\n/\n/g;
			$Classes{$K} = $V;
	}

	return %Classes;
}
#==========================================================
sub LanguagesList{
my ($Language) = @_;
my (@Files, $File);

	undef @Files;
	opendir(Dir, $Global{Language_Dir});
	foreach $File (readdir(Dir)) {
			if (-d "$Global{Language_Dir}/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
					push @Files, $File;
			}
    }
	closedir(Dir);
	return @Files;
 }
#==========================================================
sub ThemesList{
my (@Files, $File);

	undef @Files;
	opendir(Dir, "$Global{Data_Dir}/templates");
	foreach $File (readdir(Dir)) {
			if (-d "$Global{Data_Dir}/templates/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
					push @Files, $File;
			}
    }
	closedir(Dir);
	return @Files;
 }
#==========================================================
sub HTML_Editor_Code{
my ($Field, $Width, $Height) = @_;
my ($Out);

	$Width ||= "700px";
	$Height ||= "300px";
	$Plugins{JS_Code} ||= "";
	$Plugins{JS_Code} .= "initEditor();";
	$Out = &Translate_File($Global{HtmlEditor_Template});
	$Out =~ s/<!--FormField-->/$Field/g;
	$Out =~ s/<!--Width-->/$Width/g;
	$Out =~ s/<!--Height-->/$Height/g;
	$Out =~ s/<!--CLASS\:\:HTML_URL-->/$Global{HTML_URL}/g;
	return $Out;
}
#==========================================================
sub HTML_Editor_Code_Admin{
my ($Field) = @_;
my ($Out);

	$Plugins{JS_Code} ||= "";
	$Plugins{JS_Code} .= "initEditor();";
	$Out = &Translate_File($Global{HtmlEditor_Template_Admin});
	$Out =~ s/<!--FormField-->/$Field/g;
	$Out =~ s/<!--CLASS\:\:HTML_URL-->/$Global{HTML_URL}/g;
	
	return $Out;
}
#==========================================================
sub Get_IP_Hostname{
my ($IP_Address) = @_;
my (@Numbers, $IP_Number, $Host);

	@Numbers = split(/\./, $IP_Address);
	$IP_Number = pack("C4", @Numbers);
	$Host = (gethostbyaddr($IP_Number, 2))[0];
	return $Host;
}
#==========================================================

1;