=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub System_Maintenance{
my($Help);

	$Help =&Help_Link("System_Maintenance");
	&Print_Page(&System_Maintenance_Form, "System Maintenance", $Help);	
}
#==========================================================
sub System_Maintenance_Form{
my ($Out) = @_;

$Out=<<HTML;
<table border="0" width="100%" cellpadding="2" cellspacing="0" style="border-collapse: collapse">
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>Optimize your system database and remove old and unnecessary data.<br>
&nbsp;</td>
  </tr>
  <tr>
    <td>
<FORM METHOD="POST" ACTION="$Script_URL" target="_blank">
<INPUT TYPE="hidden" NAME="action" VALUE="Process_Prune_Topics">

    <table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse">
      <tr>
        <td colspan="2" nowrap><b>Prune Topics</b></td>
      </tr>
      <tr>
        <td nowrap>Delete topics older than:&nbsp; </td>
        <td nowrap>
        <input type="text" name="Prune_Topics_Days" size="10" value="$Global{Prune_Topics_Days}"> days&nbsp;&nbsp;
        </td>
      </tr>
      <tr>
        <td colspan="2" nowrap>
        <input type="submit" value="Prune Topics" name="B1"></td>
      </tr>
    </table>
</form>
    </td>
  </tr>
  
  
  <tr>
    <td>&nbsp;</td>
  </tr>
  
  <tr>
    <td>
	<FORM METHOD="POST" ACTION="$Script_URL" target="_blank">
	<INPUT TYPE="hidden" NAME="action" VALUE="Process_Prune_Pending_Users">
    <table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse">
      <tr>
        <td width="50%"><b>Prune Pending Users</b></td>
        <td width="50%">&nbsp;</td>
      </tr>
      <tr>
        <td width="50%">Delete pending and unconfirmed users older than: </td>
        <td width="50%">&nbsp;<input type="text" name="Prune_Pending_Users_Days" size="10" value="$Global{Prune_Pending_Users_Days}"> days
        </td>
      </tr>
      <tr> 
        <td width="100%" colspan="2">
        <input type="submit" value="Prune Users" name="B2"></td>
      </tr>
    </table>
	</form>
    </td>
  </tr>
  
  <tr>
    <td>&nbsp;</td>
  </tr>

  </table>


HTML
	return $Out;
}
#==========================================================
sub Process_Prune_Topics{
my (%Config, $Time, $Query, $sth, $Data, $x, @Items, $Counter);

	print "Content-type: text/html\n\n";
	print qq!<html>\n\n<head>\n<title>Pruning Topics</title>\n</head>\n\n<body>\n!;

	$Param{Prune_Topics_Days} ||= $Global{Prune_Topics_Days};
	$Global{Prune_Topics_Days} = $Param{Prune_Topics_Days};

	undef %Config;
	$Config{Prune_Topics_Days} = $Param{Prune_Topics_Days};
	&Update_Configuration(%Config);

	print "<b>Removing topics older than $Global{Prune_Topics_Days} days</b><br><br>\n";

	$Time = &Time(time) - int(86400 * $Global{Prune_Topics_Days});

	$Query = qq!SELECT Topic FROM Forum_Topics WHERE Time<=$Time!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Data = $sth->fetchall_arrayref;
	$sth->finish;
	undef @Topics;
	for $x(0..@{$Data}-1) {push @Topics, $Data->[$x][0];}
	$Global{Total_Matched_Count} = @Topics;

	print "$Global{Total_Matched_Count} Topics Found. <br>\n";
	print "Processing Now. Please Wait...<br><br>\n";
	
	$x = 0; $Counter = 0;

	foreach $Topic (@Topics) {
			print "$Topic ";
			$x++; $Counter++;
			if (!($x % 10)) {print "<br>\n<b>$Counter: </b>"; $x = 0;}
			&DeleteForumTopic($Topic);
	}
	#------------------------------------------------------
	&UpdateForumsCounts;
	#------------------------------------------------------
	print "<br>Done.<br><br>";
	print qq!<P ALIGN="center"><A HREF="javascript:window.close()"><B><FONT COLOR="BLUE">Close This Window</FONT></B></A></P>!;	
	print qq!</body>\n\n</html>\n!;	

}
#==========================================================
sub Process_Prune_Pending_Users{
my(%Config, $Start_Date, $Query, $sth, $Data, $x, @Users, $Counter);

	print "Content-type: text/html\n\n";
	print qq!<html>\n\n<head>\n<title>Pruning Pending Users</title>\n</head>\n\n<body>\n!;

	$Param{Prune_Pending_Users_Days} ||= $Global{Prune_Pending_Users_Days};
	$Global{Prune_Pending_Users_Days} = $Param{Prune_Pending_Users_Days};

	undef %Config;
	$Config{Prune_Pending_Users_Days} = $Param{Prune_Pending_Users_Days};
	&Update_Configuration(%Config);

	print "<b>Removing pending and unconfirmed users older than $Global{Prune_Pending_Users_Days} days</b><br><br>\n";

	$Start_Date = &Time(time) - int(86400 * $Global{Prune_Pending_Users_Days});

	$Query = qq!SELECT User_ID FROM Pending_Users WHERE Start_Date < $Start_Date!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Data = $sth->fetchall_arrayref;
	$sth->finish;
	undef @Users;
	for $x(0..@{$Data}-1) {push @Users, $Data->[$x][0];}
	$Global{Total_Matched_Count} = @Users;

	print "$Global{Total_Matched_Count} Pending Users. <br>\n";
	print "Processing Now. Please Wait...<br><br>\n";
	
	$x = 0; $Counter = 0;

	foreach $User (@Users) {
			print "$User ";
			$x++; $Counter++;
			if (!($x % 10)) {print "<br>\n<b>$Counter: </b>"; $x = 0;}
			&Delete_Pending_User($User);
	}

	print "<br>Done.<br><br>";
	print qq!<P ALIGN="center"><A HREF="javascript:window.close()"><B><FONT COLOR="BLUE">Close This Window</FONT></B></A></P>!;	
	print qq!</body>\n\n</html>\n!;	

}
#==========================================================
1;