=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ViewTopic{
my ($Template, $Out, $Msgs, $Topic, $Query, $User);

	$Plugins{Bar_Action} = $Language{bar_view_topic};
	$Template = &Translate_File($Global{ForumViewTopic_Template});
	$Topic = $Param{Topic};
	
	if ($Topic) {
		($Out, $Msgs) = &ParseTopic("action=ViewTopic", $Param{Topic}, $Global{Forum_Post_List_Form}, $Global{Forum_Post_List_Form1}, $Template);
	}
	
	#------------------------------------------------------
	# Update view topics count
	$Query = qq!UPDATE Forum_Topics SET Views=(Views+1) WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# mark topic as read for this user
	$Param{User_ID} ||= "";
	if (&Check_Previous_User_Login) {
			$User = $dbh->quote($Param{User_ID});
			$Query = qq!DELETE From Forum_Topic_Read WHERE Topic=$Topic AND User=$User!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			
			$Query = qq!INSERT INTO Forum_Topic_Read SET Topic=$Topic, User=$User!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	# if current user is watching this topic, reset the sent notify email status
	&UpdateNotifyTopicUsersList($Topic, 0, $Param{User_ID});
	#------------------------------------------------------
	&Display($Out, 1);
}
#==========================================================
sub TopicReview{
my ($Template, $Out, $Msgs);

	$Template = &Translate_File($Global{ForumTopicReview_Template});
	($Out, $Msgs) = &ParseTopic("action=TopicReview", $Param{Topic}, $Global{Forum_Post_List_Review_Form}, $Global{Forum_Post_List_Review_Form1}, $Template);
	&Display($Out, 1);
}
#==========================================================
sub ParseTopic{
my ($Action, $Topic, $Form1, $Form2, $Template) = @_;
my (@Posts, %Topic, %Forum, $Temp, $Temp1, $Code, @Code);

	@Posts = &GetForumTopicPosts($Topic);
	%Topic = &GetForumTopic($Topic);
	%Forum = &GetForum($Topic{Forum});

	$Param{Forum} = $Topic{Forum};

	#@Forms = (&Translate($Global{Forum_Post_List_Form}), &Translate($Global{Forum_Post_List_Form1}));
	@Forms = (&Translate($Form1), &Translate($Form2));
	#------------------------------------------------------
	$Param{Page} ||= 1;
	$Total_Count = @Posts;
	$Global{Posts_Per_Page} ||= 10;
	$Last_Page = int ($Total_Count / $Global{Posts_Per_Page});
	if (($Total_Count % $Global{Posts_Per_Page})) {$Last_Page++;}
	$Current_Page = $Param{Page};
	$Next_Page = $Current_Page + 1;
	$Previous_Page = $Current_Page - 1;
	if ($Next_Page > $Last_Page) {$Next_Page = $Last_Page;}
	#----------------------------------------------
	$Next_Page_URL = qq!$Script_URL?$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$Next_Page&Lang=$Global{Language}!;
	$Previous_Page_URL = qq!$Script_URL?$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$Previous_Page&Lang=$Global{Language}!;
	#----------------------------------------------
	if ($Current_Page == $Last_Page || $Total_Count <= 0) {
			$Temp = $Language{posts_last_page};
	}
	else{
			$Temp = $Language{posts_next_page};
			$Temp =~ s/<!--Next_Page_URL-->/$Next_Page_URL/g;
	}
	$Template =~ s/<!--Next_Page-->/$Temp/g;

	if ($Current_Page == 1) {
			$Temp = $Language{posts_first_page};
	}
	else{
			$Temp = $Language{posts_previous_page};
			$Temp =~ s/<!--Previous_Page_URL-->/$Previous_Page_URL/g;
	}
	$Template =~ s/<!--Previous_Page-->/$Temp/g;
	#----------------------------------------------
	$Pages = ""; 
	@Pages = &PagesNumbers($Current_Page, $Last_Page);

	foreach $Page(@Pages) {
			if ($Page == $Current_Page) {
					$Link = $Language{posts_current_page_link};
			}
			else{
					$Link = $Language{posts_pages_link};
			}
			$Temp = qq!$Script_URL?$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$Page&Lang=$Global{Language}!;
			$Link =~ s/<!--Link-->/$Temp/;
			$Link =~ s/<!--Page-->/$Page/;
			$Pages .= $Link;
			if ($Page != $Last_Page) {
					$Pages .= $Language{posts_pages_link_separtor};
			}
	}
	$Pages =~ s/$Language{posts_pages_link_separtor}$//g;
	$Template =~ s/<!--Pages-->/$Pages/g;
	#----------------------------------------------
	$Temp = $Language{posts_showing_page};
	$Temp =~ s/<!--CurrentPage-->/$Current_Page/g;
	$Temp =~ s/<!--TotalPages-->/$Last_Page/g;
	$Template =~ s/<!--Showing_Page-->/$Temp/g;
	#------------------------------------------------------
	$PostTimeClass = ""; $PostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Forms[0] =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
				$PostTimeClass = $1 . $2 . $3. $4. $5;
				$PostTimeFormat =  $4;
	}
	$PostTimeClass =~ s/\(/\\\(/g;
	$PostTimeClass =~ s/\)/\\\)/g;
	#------------------------------------------------------
	$Start = ($Current_Page - 1) * $Global{Posts_Per_Page};
	$End = $Start + $Global{Posts_Per_Page};
	if ($End > $Total_Count) {$End = $Total_Count;}
	#------------------------------------------------------
	$Output = "";
	$PrevPost = ""; $NextPost = "";
	for $Counter($Start..$End-1){
					$Post = $Posts[$Counter];
					
					%Post = &GetForumPost($Post);
					%Media = &GetForumPostMedia($Post);
					%User = &GetForumUser($Post{Author});

					$Form = $Forms[int($Counter % 2)]; 

					$Temp = "";
					if ($Topic{Poll}) {$Temp = $Language{topic_has_poll};}
					$Form =~ s/<!--Poll-->/$Temp/g;

					%Message = &GetForumMessage($Post);
					#------------------------------------------------------
					if ($Message{Subject}) {
							$Temp = $Message{Subject};
							$Form =~ s/<!--Subject-->/$Temp/g;
					}
					else{
							$Temp = $Language{posts_subject};
							$Temp =~ s/<!--Subject-->/$Topic{Title}/g;
							$Form =~ s/<!--Subject-->/$Temp/g;
					}
					#------------------------------------------------------
					# Process the [code] ..[/code]
					$Message = $Message{Message};
					@Code = $Message =~/\[code\](.*?)\[\/code\]/igs;
					foreach $Code (@Code) {
							$Temp = $Code;
							$Temp =~ s/\</\&lt\;/g;
							$Temp =~ s/\>/\&gt\;/g;
							$Temp1 = $Global{Forum_Post_Code};
							$Temp1 =~ s/<!--Message-->/$Temp/;
							$Message =~ s/\[code\]\Q$Code\E\[\/code\]/$Temp1/s;
					}

					$Message =~ s/\\\n/\n/g;
					$Message =~ s/[\>]\s*\n/\> /g;
					$Message =~ s/\n/\<br\>/g;

					$Form =~ s/<!--Message-->/$Message/g;
					#------------------------------------------------------
					$Form =~ s/<!--ID-->/$Post/g;
					#------------------------------------------------------
					if ($User{AttachSign} && $User{Sig}) {
							$Temp = $Language{posts_signature};
							$Temp =~ s/<!--Sig-->/$User{Sig}/;
							$Temp =~ s/\\\n/\n/g;
							$Form =~ s/<!--Signature-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--Signature-->//g;
					}
					#------------------------------------------------------
					if ($User{Avatar}) {
							$Temp = $Language{post_avatar_link};
							$Link = qq!$Global{Avatars_URL}/$User{Avatar}!;
							$Temp =~ s/<!--AvatarLink-->/$Link/g;
							$Form =~ s/<!--Avatar-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--Avatar-->//g;
					}
					#------------------------------------------------------
					$Temp = qq!$Script_URL?action=ViewProfile&Author=$Post{Author}&Forum=$Topic{Forum}&Lang=$Global{Language}!;
					$Form =~ s/<!--AuthorLink-->/$Temp/g;
					#------------------------------------------------------
					$Temp = $Language{edit_with_quote};
					$Link = qq!$Script_URL?action=QuotePost&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
					$Temp =~ s/<!--QuoteLink-->/$Link/g;
					$Form =~ s/<!--QuotePost-->/$Temp/g;
					#------------------------------------------------------
					if (&CheckPostActionPermissions("Edit", %Post)) {
							$Temp = $Language{post_edit_link};
							$Link = qq!$Script_URL?action=EditPost&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--EditLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_edit_link_disabled};
					}
					$Form =~ s/<!--EditPost-->/$Temp/g;
					#------------------------------------------------------
					if (&CheckPostActionPermissions("Deletes", %Post)) {
							$Temp = $Language{post_delete_link};
							$Link = qq!$Script_URL?action=DeletePost&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--DeleteLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_delete_link_disabled};
					}
					$Form =~ s/<!--DeletePost-->/$Temp/g;
					#------------------------------------------------------
					$Temp = qq!$Script_URL?action=ViewIP&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
					$Form =~ s/<!--IPLink-->/$Temp/g;
					if (&CheckPostActionPermissions("Deletes", %Post)) {
							$Temp = $Language{post_viewip_link};
							$Link = qq!$Script_URL?action=ViewIP&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--IPLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_viewip_link_disabled};
					}
					$Form =~ s/<!--PostIP-->/$Temp/g;
					#------------------------------------------------------
					if ($User{AllowPM}) {
							$Temp = $Language{post_pm_link};
							$Link = qq!$Script_URL?action=MyCompose&To=$Post{Author}&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--PMLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_pm_link_disabled};
					}
					$Form =~ s/<!--PM-->/$Temp/g;
					#------------------------------------------------------
					if ($User{ICQ}) {
							$Temp = $Language{post_icq};
							$Temp =~ s/<!--ICQ-->/$User{ICQ}/g;
							$Form =~ s/<!--ICQ-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--ICQ-->//g;
					}
					if ($User{AIM}) {
							$Temp = $Language{post_aim};
							$Temp =~ s/<!--AIM-->/$User{AIM}/g;
							$Form =~ s/<!--AIM-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--AIM-->//g;
					}
					if ($User{YIM}) {
							$Temp = $Language{post_yim};
							$Temp =~ s/<!--YIM-->/$User{YIM}/g;
							$Form =~ s/<!--YIM-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--YIM-->//g;
					}
					if ($User{MSNM}) {
							$Temp = $Language{post_msnm};
							$Temp =~ s/<!--MSNM-->/$User{MSNM}/g;
							$Form =~ s/<!--MSNM-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--MSNM-->//g;
					}

					if ($User{WebURL}) {
							$User{WebTitle} ||= $User{WebURL};
							$Temp = $Language{post_weburl};
							$Temp =~ s/<!--WebURL-->/$User{WebURL}/g;
							$Temp =~ s/<!--WebTitle-->/$User{WebTitle}/g;
							$Form =~ s/<!--WebSite-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--WebSite-->//g;
					}
					#------------------------------------------------------
					if (($User{ViewEmail} && $Global{ShowUserEmail}) || $CurrentUser{Level} == 1) {
							$Temp = $Language{post_email};
							$Temp =~ s/<!--Email-->/$User{Email}/g;
					}
					else{
							$Temp = $Language{post_email_disabled};
					}
					$Form =~ s/<!--Email-->/$Temp/g;
					#----------------------------------------------
					$Temp = $Language{post_member_posts};
					$Link = qq!$Script_URL?action=ForumSmartSearch&Authors=$User{User_ID}&Dir=0&Sort=Updated&Mode=1&Period=0&TitlesOnly=1&&Terms=&Lang=$Global{Language}!;
					$Temp =~ s/<!--AuthorPostsLink-->/$Link/g;
					$Form =~ s/<!--AuthorPosts-->/$Temp/g;
					#----------------------------------------------
					$Form =~ s/<!--Posts-->/$User{Posts}/g;
					#----------------------------------------------
					if ($User{Location}) {
							$Temp = $Language{posts_user_location};
							$Temp =~ s/<!--Location-->/$User{Location}/g;
							$Form =~ s/<!--Location-->/$Temp/g;
					}
					#----------------------------------------------
					$Temp = $Post{Author};
					$Form =~ s/<!--Author-->/$Temp/g;

					#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
					if ($Post{Time} > 0) {
							$Temp = &ParseDate($PostTimeFormat, $Post{Time});
					}
					else{	
							$Temp = "";
					}
					$Form =~ s/$PostTimeClass/$Temp/g;

					$Form =~ s/<!--Counter-->/$Counter/g;
					#------------------------------------------------------
					if ($Media{Media}) {
							undef @Media; undef @Docs;
							@Upload = split(/\|/, $Media{Media});
							foreach $File (@Upload) {
								if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
									push @Media, $File;
								}
								else{
									push @Docs, $File;
								}
							}
							$Temp = &Get_Media_Show($Media{Media_Show}, @Media);
							$Form =~ s/<!--Multimedia-->/$Temp/;
							
							$Docs = "";
							foreach $File (@Docs) {
									if ($File =~ /\.wav$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_sound};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									elsif ($File =~ /\.mid$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_mid};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									elsif ($File =~ /\.mov$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_movie};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									elsif ($File =~ /\.avi$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_avi};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									else{
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_other};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									$Docs .= $URL . $Language{docs_files_join};
							}
							$Docs =~ s/$Language{docs_files_join}$//g;
							$Form =~ s/<!--Documents-->/$Docs/;
			}
			#------------------------------------------------------
			$Temp = qq!$Script_URL?action=ViewProfile&Author=$Post{Author}&Forum=$Topic{Forum}&Lang=$Global{Language}!;
			$Form =~ s/<!--Profile-->/$Temp/g;
			#------------------------------------------------------
			$Temp = $Counter;
			if ($Counter == 0) {
					$Link = $Language{post_first_number};
			}
			else{
					$Link = $Language{post_number};
			}
			$Link =~ s/<!--PostNum-->/$Temp/g;
			$Form =~ s/<!--PostNum-->/$Link/g;
			#------------------------------------------------------
			if ($PrevPost) {
					$Temp = $Language{posts_up_post};
					$Temp =~ s/<!--UpPost-->/$PrevPost/g;
					$Form =~ s/<!--UpPost-->/$Temp/g;
			}
			else{
					$Form =~ s/<!--UpPost-->/$Language{posts_up_post_disabled}/g;
			}
			
			if ($Counter < $End-1) {
					$NextPost = $Posts[$Counter+1];
					$Temp = $Language{posts_dn_post};
					$Temp =~ s/<!--DnPost-->/$NextPost/g;
					$Form =~ s/<!--DnPost-->/$Temp/g;
			}
			else{
					$Form =~ s/<!--DnPost-->/$Language{posts_dn_post_disabled}/g;
			}

			$PrevPost = $Post;
			#------------------------------------------------------
			if ($Global{Auctionawy_Plugin}) {
					($Rating, $Stars) = &Get_User_Feedback_Stars($Post{Author});
					if (!$Rating) {
							$Temp = $Language{feedback_rating_zero};
					}
					else{
							$Temp = $Language{feedback_rating};
							$Temp =~ s/<!--FeedbackRating-->/$Rating/g;
							$Temp =~ s/<!--FeedbackStars-->/$Stars/g;
					}
					$Form =~ s/<!--Feedback-->/$Temp/g;
			}
			#------------------------------------------------------
			$Temp = $Language{about_me_link};
			$Link = qq!$Global{AboutMe_URL}/$Post{Author}!;
			$Temp =~ s/<!--AboutMeLink-->/$Link/g;
			$Temp =~ s/<!--Author-->/$Post{Author}/g;
			$Form =~ s/<!--AboutMe-->/$Temp/g;
			#------------------------------------------------------
			$Output .= $Form;
	}
	#------------------------------------------------------
	if ($Forum{Status} == 1 && $Forum{Accept}) {$PostLink = 1;} else {$PostLink = 0;	}
	# display the post new topic link?
	if ($PostLink && &CheckForumActionPermissions("Post", %Forum)) {
					$Link = $Language{topicview_post_new_topic};
					$Temp = qq!$Script_URL?action=NewTopic&Forum=$Param{Forum}&Lang=$Global{Language}!;
					$Link =~ s/<!--NewTopicLink-->/$Temp/g;
	}
	else{
					$Link = $Language{topicview_post_new_topic_disabled};
	}
	$Template =~ s/<!--PostNewTopic-->/$Link/g;

	if ($PostLink && !$Topic{Status} && &CheckForumActionPermissions("Reply", %Forum)) {
					$Link = $Language{topicview_post_new_reply};
					$Temp = qq!$Script_URL?action=NewPost&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
					$Link =~ s/<!--NewReplyLink-->/$Temp/g;
	}
	else{
					$Link = $Language{topicview_post_new_reply_disabled};
	}
	$Template =~ s/<!--PostNewReply-->/$Link/g;
	#------------------------------------------------------
	#<!--DeleteTopic--> &nbsp; <!--MoveTopic--> &nbsp; <!--CopyTopic--> &nbsp; <!--StatusTopic--> &nbsp;
	if (&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Link = $Language{topic_delete_link};
				$Temp = qq!$Script_URL?action=DeleteTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
				$Link =~ s/<!--DeleteTopicLink-->/$Temp/g;
				$Template =~ s/<!--DeleteTopic-->/$Link/g;

				$Link = $Language{topic_move_link};
				$Temp = qq!$Script_URL?action=MoveTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
				$Link =~ s/<!--MoveTopicLink-->/$Temp/g;
				$Template =~ s/<!--MoveTopic-->/$Link/g;

				$Link = $Language{topic_copy_link};
				$Temp = qq!$Script_URL?action=CopyTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
				$Link =~ s/<!--CopyTopicLink-->/$Temp/g;
				$Template =~ s/<!--CopyTopic-->/$Link/g;

				if (!$Topic{Status}) { # open topic
						$Link = $Language{topic_lock_link};
						$Temp = qq!$Script_URL?action=StatusTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
						$Link =~ s/<!--StatusLink-->/$Temp/g;
				}
				else{ # locked topic
						$Link = $Language{topic_unlock_link};
						$Temp = qq!$Script_URL?action=StatusTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
						$Link =~ s/<!--StatusLink-->/$Temp/g;
				}
				$Template =~ s/<!--StatusTopic-->/$Link/g;
	}
	else{
				$Template =~ s/<!--DeleteTopic-->/$Language{topic_delete_disabled}/g;
				$Template =~ s/<!--MoveTopic-->/$Language{topic_move_disabled}/g;
				$Template =~ s/<!--CopyTopic-->/$Language{topic_copy_disabled}/g;
				if (!$Topic{Status}) { # open topic
						$Template =~ s/<!--StatusTopic-->/$Language{topic_lock_link_disabled}/g;
				}
				else{ # locked topic
						$Template =~ s/<!--StatusTopic-->/$Language{topic_unlock_link_disabled}/g;
				}
	}
	#------------------------------------------------------
	#<!--EmailTopic--> &nbsp; <!--WatchTopic--> &nbsp; <!--NotifyTopic--> &nbsp; <!--PrintTopic--> &nbsp; <!--DownloadTopic-->
	#------------------------------------------------------
	$Link = $Language{topic_email_link};
	$Temp = qq!$Script_URL?action=EmailTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--EmailTopicLink-->/$Temp/g;
	$Template =~ s/<!--EmailTopic-->/$Link/g;
	#------------------------------------------------------
	if (&WatchingTopicStatus($Param{User_ID}, $Topic)) {
				$Link = $Language{topic_unwatch_link};
	}
	else{
				$Link = $Language{topic_watch_link};
	}
	$Temp = qq!$Script_URL?action=WatchTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--WatchTopicLink-->/$Temp/g;
	$Template =~ s/<!--WatchTopic-->/$Link/g;
	#------------------------------------------------------
	if (&NotifyTopicStatus($Param{User_ID}, $Topic)) {
				$Link = $Language{topic_unnotify_link};
	}
	else{
				$Link = $Language{topic_notify_link};
	}
	$Temp = qq!$Script_URL?action=NotifyTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--NotifyTopicLink-->/$Temp/g;
	$Template =~ s/<!--NotifyTopic-->/$Link/g;
	#------------------------------------------------------
	$Link = $Language{topic_print_link};
	$Temp = qq!$Script_URL?action=PrintTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--PrintTopicLink-->/$Temp/g;
	$Template =~ s/<!--PrintTopic-->/$Link/g;
	#------------------------------------------------------
	$Link = $Language{topic_download_link};
	$Temp = qq!$Script_URL?action=DownloadTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--DownloadTopicLink-->/$Temp/g;
	$Template =~ s/<!--DownloadTopic-->/$Link/g;
	#------------------------------------------------------
	$Template =~ s/<!--MessagesList-->/$Output/g;
	return ($Template, $Output);
}
#==========================================================

1;