=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Banner_Manager{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Manager_Form, "Banners System Manager", $Help);	

}
#==========================================================
sub Banner_Manager_Form{
my($Out);

$Out=<<HTML;
<BR>
<TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="8">
  <TR><TD WIDTH="100%">$Global{G1_Bullet}<A HREF="$Script_URL?action=Add_New_Banner_Account">Add New Account</A></TD></TR>
  <TR><TD WIDTH="100%">$Global{G1_Bullet}<A HREF="$Script_URL?action=Add_New_Banner_Campaign">Add New Campaign</A></TD></TR>
  <TR><TD WIDTH="100%">$Global{G1_Bullet}<A HREF="$Script_URL?action=Manage_Banner_Accounts">Manage Accounts</A></TD></TR>
  <TR><TD WIDTH="100%">$Global{G1_Bullet}<A HREF="$Script_URL?action=Manage_Banner_Campaigns">Manage Campaigns</A></TD></TR>
  <TR><TD WIDTH="100%">$Global{G1_Bullet}<A HREF="$Script_URL?action=Manage_Banner_Zones">Manage Zones</A></TD></TR>
<!--
<TR><TD WIDTH="100%">$Global{G1_Bullet}<A HREF="$Script_URL?action=Edit_Banner_Templates">Edit Banner Templates</A></TD></TR>
	-->
</TABLE>
HTML
	
	return $Out;

}
#==========================================================
sub Manage_Banner_Zones{
my ($Help);

	$Help = &Help_Link("Banner_Zones");
	&Print_Page(&Zones_Manager_Form, "Zones Manager", $Help);	
}
#==========================================================
sub Zones_Manager_Form{
my($Out, $Form, $Count, $Table);
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth);

	$Query = qq!SELECT * FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Count = 0;
	while(($Zone, $Default_Zone, $Default_Campaign) = $sth->fetchrow_array) {
			$Zones[$Count]{Zone} = $Zone;
			$Zones[$Count]{Default_Zone} = $Default_Zone;
			$Zones[$Count]{Default_Campaign} = $Default_Campaign;
			$Count++;
	}

	$sth->finish;

	if (!$Param{Page}) {$Param{Page} = 1;}

	$Total_Count = @Zones;
	$Last_Page = int ($Total_Count / 10);
	if (($Total_Count % 10)) { $Last_Page++; }
	$Current_Page = $Param{Page};
	$Next_Page = $Current_Page + 1;
	$Previous_Page = $Current_Page - 1;
	if ($Next_Page > $Last_Page) {$Next_Page = $Last_Page;}
	$Next_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Zones&Page=$Next_Page">Next Page</A>!;
	$Previous_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Zones&Page=$Previous_Page">Previous Page</A>!;

	$Start = ($Current_Page - 1) * 10;
	$End = $Start + 10;
	if ($End > $Total_Count) {$End = $Total_Count;}

	if ($Current_Page == $Last_Page || $Total_Count <= 0) {
			$Next_Page = "Next Page";
	}
	else{
			$Next_Page = $Next_Page_Link;
	}

	if ($Current_Page == 1) {
			$Previous_Page = "Previous Page";
	}
	else{
			$Previous_Page = $Previous_Page_Link;
	}

	$Table = "";
	for $Count($Start..$End-1) {
		$x = $Count+1;
		$Zone = &Web_Encode($Zones[$Count]{Zone});
$Form =<<HTMLf;
	  <TR>
        <TD ALIGN="center">&nbsp;$x</TD>
        <TD WIDTH="30%" ALIGN="left">&nbsp; 
		<A HREF="$Script_URL?action=Configure_Banner_Zone&Zone=$Zones[$Count]{Zone}">$Zones[$Count]{Zone}</A>
		</TD>
        <TD WIDTH="30%" ALIGN="left">&nbsp; $Zones[$Count]{Default_Zone}</TD>
        <TD WIDTH="30%" ALIGN="left">&nbsp; $Zones[$Count]{Default_Campaign}</TD>
        <TD ALIGN="center"><A HREF="$Script_URL?action=Configure_Banner_Zone&Zone=$Zone">Config</A></TD>
		<TD ALIGN="center"><A HREF="#" onClick="Delete_Banner_Zone_Confirm('$Zone', '$Zones[$Count]{Zone}'); return false;">Delete</A></TD>
      </TR>
HTMLf
			
		$Table .= $Form;
	}


$Out=<<HTML;
<BR>
<DIV ALIGN="center">
  <CENTER>
  <FORM METHOD="POST" ACTION="$Script_URL">
    <TABLE BORDER="1" WIDTH="98%" CELLPADDING="5" CELLSPACING="0" $Global{Admin_Table_Attr}>
      <TR>
        <TD ALIGN="center" BGCOLOR="#E7E7CF"><FONT SIZE="3"><B>#</B></FONT></TD>
        <TD WIDTH="30%" ALIGN="center" BGCOLOR="#E7E7CF"><FONT SIZE="3"><B>Zone</B></FONT></TD>
        <TD WIDTH="30%" ALIGN="center" BGCOLOR="#E7E7CF"><FONT SIZE="3"><B>Default
          Zone</B></FONT></TD>
        <TD WIDTH="30%" ALIGN="center" BGCOLOR="#E7E7CF"><FONT SIZE="3"><B>Default
          Campaign</B></FONT></TD>
        <TD ALIGN="center" BGCOLOR="#E7E7CF" COLSPAN="2"><FONT SIZE="3"><B>Action</B></FONT></TD>
      </TR>

	$Table

      <TR>
        <TD ALIGN="right" COLSPAN="6"><B>
			$Previous_Page &nbsp;&nbsp; $Next_Page
			&nbsp;&nbsp;&nbsp;
        </TD>
      </TR>
      <TR>
        <TD ALIGN="center" COLSPAN="6">
			<INPUT TYPE="submit" VALUE="Save Changes" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </TD>
      </TR>
    </TABLE>
  </FORM>
  </CENTER>
</DIV>
<P>&nbsp;</P>
<DIV ALIGN="center">
  <CENTER>
   <FORM METHOD="POST" ACTION="$Script_URL">
  <TABLE BORDER="1" WIDTH="98%" CELLPADDING="2" CELLSPACING="0" $Global{Admin_Table_Attr}>
    <TR>
      <TD ALIGN="center" BGCOLOR="#E7E7CF"><B><FONT SIZE="4">Create New Zones</FONT></B></TD>
    </TR>
    <TR>
      <TD ALIGN="center">Please enter one zone name per each line and press
        enter key at the end of each line.
          <INPUT TYPE="hidden" NAME="action" VALUE="Create_New_Banner_Zones">

		  <TEXTAREA ROWS="7" NAME="New_Zones_Names" COLS="46"></TEXTAREA>
			 <BR>
		  <INPUT TYPE="submit" VALUE="Create Zones" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
      </TD>
    </TR>
  </TABLE>
    </FORM>
 </CENTER>
</DIV>

<SCRIPT LANGUAGE="JavaScript">
<!--
function Delete_Banner_Zone_Confirm(Zone_Encoded, Zone) {
	var agree=confirm("Are you sure you want to Delete the ["+Zone+"] banner Zone\\n");
	if (agree){
			var agree=confirm("Please note once the Zone deleted, you will not be able to recover it again\\nAre you sure you still want to delete this zone ["+Zone+"]\\n");
			if (agree){
				window.location = "$Script_URL?action=Delete_Banner_Zone&Zone=" +Zone_Encoded;
			}
	}
}
-->
</SCRIPT>
HTML
	
	return $Out;

}
#==========================================================
sub Delete_Banner_Zone{

	$Param{Zone} = $dbh->quote($Param{Zone});

	$Query = qq!DELETE FROM Banner_Zones WHERE Zone=$Param{Zone}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Zones;

}
#==========================================================
sub Create_New_Banner_Zones{

	$Query = qq!SELECT Zone FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Zone) = $sth->fetchrow_array) {
			$Zones{$Zone} = 1;;
	}
	$sth->finish;


	@Zones = split (/\n/, $Param{New_Zones_Names});
	foreach $Zone (@Zones) {
				$Zone =~ s/\r+$//;
				$Zone =~ s/\n+$//;
				$Zone =~ s/^\s+//;
				$Zone =~ s/\s+$//;
				if ($Zones{$Zone}) {next;}

				$Zone =$dbh->quote($Zone);
				$Query = qq!INSERT INTO Banner_Zones VALUES($Zone, '', '')!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);		
	}
	$sth->finish;

	&Manage_Banner_Zones;

}
#==========================================================
sub Configure_Banner_Zone{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Configure_Banner_Zone_Form, "Banner Manager", $Help);
}
#==========================================================
sub Configure_Banner_Zone_Form{
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth);
my($Out);

	$Param{Zone} = $dbh->quote($Param{Zone});
	$Query = qq!SELECT * FROM Banner_Zones WHERE Zone=$Param{Zone} ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {($Zone_Name, $Default_Zone, $Default_Campaign) = @Row;}
	$sth->finish;

	$Query = qq!SELECT Zone FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Default_Zone_Menu .= "";
	while($Zone = $sth->fetchrow_array) {
			$Temp = &Web_Encode($Zone);
			$Temp1 = "";
			if ($Default_Zone eq $Zone) {$Temp1 = "SELECTED";}
			$Default_Zone_Menu .= qq!<OPTION VALUE="$Temp" $Temp1>$Zone!;
	}
	$Temp1 = "";
	if ($Default_Zone eq "") {$Temp1 = "SELECTED";}
	$Default_Zone_Menu .= qq!<OPTION VALUE="" $Temp1>!;
	$sth->finish;

	$Query = qq!SELECT Campaign FROM Banner_Campaigns ORDER BY Account ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Default_Campaing_Menu = "";
	while($Zone = $sth->fetchrow_array) {
			$Temp = &Web_Encode($Zone);
			$Temp1 = "";
			if ($Default_Campaign eq $Zone) {$Temp1 = "SELECTED";}
			$Default_Campaing_Menu .= qq!<OPTION VALUE="$Temp" $Temp1>$Zone!;
	}
	$Temp1 = "";
	if ($Default_Campaign eq "") {$Temp1 = "SELECTED";}
	$Default_Campaing_Menu .= qq!<OPTION VALUE="" $Temp1>!;
	$sth->finish;

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Script_URL">
<INPUT TYPE="hidden" NAME="action" VALUE="Save_Configure_Banner_Zone">
<INPUT TYPE="hidden" NAME="Zone" VALUE="$Param{Zone}">
  <DIV ALIGN="center">
    <CENTER>
    <TABLE BORDER="1" WIDTH="90%" CELLSPACING="0" CELLPADDING="5" $Global{Admin_Table_Attr}>
      <TR>
        <TD WIDTH="100%" COLSPAN="2" ALIGN="center" HEIGHT="25" BGCOLOR="#E7E7CF"><B><FONT SIZE="4">Banner
          Zone Configuration</FONT></B></TD>
      </TR>
      <TR>
        <TD>Zone Name:</TD>
        <TD WIDTH="50%" HEIGHT="19">&nbsp; $Zone_Name</TD>
      </TR>
      <TR>
        <TD>Default Zone:</TD>
        <TD WIDTH="50%" HEIGHT="22">&nbsp;
		
		<SELECT SIZE="1" NAME="Default_Zone">
		$Default_Zone_Menu
          </SELECT>
			
		</TD>
      </TR>
      <TR>
        <TD>Default Campaign:</TD>
        <TD WIDTH="50%" HEIGHT="19">&nbsp;
	
		<SELECT SIZE="1" NAME="Default_Campaign">
		$Default_Campaing_Menu
          </SELECT>
	
</TD>
      </TR>
      <TR>
        <TD COLSPAN="2" ALIGN="center"><INPUT TYPE="submit" VALUE="Save Changes" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_Configure_Banner_Zone{

	$Param{Default_Zone} = $dbh->quote(&Web_Decode($Param{Default_Zone}));
	$Param{Default_Campaign} = $dbh->quote(&Web_Decode($Param{Default_Campaign}));
	
	if (!$Param{Default_Zone}) {$Param{Default_Zone} = '';}
	if (!$Param{Default_Campaign}) {$Param{Default_Campaign} = '';}

	$Query = qq!UPDATE Banner_Zones SET Default_Zone=$Param{Default_Zone} , Default_Campaign=$Param{Default_Campaign} WHERE Zone=$Param{Zone}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	
	&Manage_Banner_Zones;
}
#==========================================================
sub Add_New_Banner_Account{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Account_Form(""), "Create New Banner Account", $Help);
}
#==========================================================
sub Banner_Account_Form{
my($Required_Account) = @_;
my($Query, $sth);
my($Out, %Account);
	
	undef %Account;

	if ($Required_Account) {
			$Required_Account = $dbh->quote($Required_Account);
			$Query = qq!SELECT * FROM Banner_Accounts WHERE Account=$Required_Account!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Account = "";
			while ($Temp = $sth->fetchrow_hashref){%Account = %{$Temp};}
			$sth->finish;
			$Title ="Edit Banner Account";
	}
	else{
			$Title ="Create New Banner Account";
	}

	if ($Account{Account}) {
			$Account_ID = $Account{Account};
			$Param{Edit_Account} = "$Account{Account}";
	}
	else{
		$Account_ID = qq!<INPUT TYPE="text" NAME="Account" VALUE="$Account{Account}" SIZE="20">!;
		$Param{Edit_Account} = "";
	}

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Script_URL">
 <INPUT TYPE="hidden" NAME="action" VALUE="Save_New_Banner_Account">
 <INPUT TYPE="hidden" NAME="Edit_Account" VALUE="$Param{Edit_Account}">
<DIV ALIGN="center">
    <CENTER>
    <TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3" $Global{Admin_Table_Attr}>
      <TR>
        <TD NOWRAP>Account ID:</TD>
        <TD WIDTH="100%" NOWRAP>$Account_ID</TD>
      </TR>
      <TR>
        <TD NOWRAP>Login Password:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT NAME="Password" SIZE="20"  VALUE="$Account{Password}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>Email Address:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Email" SIZE="30"  VALUE="$Account{Email}" ></TD>
      </TR>

		<TR>
        <TD NOWRAP>Full Name:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Name" SIZE="30"  VALUE="$Account{Name}" ></TD>
      </TR>

      <TR>
        <TD NOWRAP>Company:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Company" SIZE="30"  VALUE="$Account{Company}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>Street Address:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Street" SIZE="30"  VALUE="$Account{Street}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>City:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="City" SIZE="20"  VALUE="$Account{City}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>State:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="State" SIZE="20"  VALUE="$Account{State}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>Zip:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Zip" SIZE="15"  VALUE="$Account{Zip}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>Country:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Country" SIZE="20"  VALUE="$Account{Country}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>Phone:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Phone" SIZE="20"  VALUE="$Account{Phone}" ></TD>
      </TR>
      <TR>
        <TD NOWRAP>Fax: </TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Fax" SIZE="20"  VALUE="$Account{Fax}" ></TD>
      </TR>
      <TR>
        <TD VALIGN="top" NOWRAP>Comments or <BR>Payment Information:</TD>
        <TD WIDTH="100%" NOWRAP><TEXTAREA ROWS="10" NAME="Comments" COLS="60">$Account{Comments}</TEXTAREA></TD>
      </TR>
      <TR>
        <TD COLSPAN="2" ALIGN="center"><INPUT TYPE="submit" VALUE="Submit" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_New_Banner_Account{
my($Msg, $Out);
my ($Help);

	$Help = &Help_Link("Banner_Manager");

	$Msg = "";

	$Param{Account} =~ s/^\s+//;
	$Param{Account} =~ s/\s+$//;
	$Param{Password} =~ s/^\s+//g;
	$Param{Password} =~ s/\s+$//g;
	

	if (!$Param{Edit_Account}) {
		if (!$Param{Account}) {$Msg = "Please Enter Account ID.<BR>";}
	}
	if (!$Param{Password}){$Msg .= "Please Enter Password.<BR>";}

	$Param{Account} =$dbh->quote($Param{Account});
	
	if (!$Param{Edit_Account}) {
			$Query = qq!SELECT count(*) FROM Banner_Accounts WHERE Account=$Param{Account}!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while(@Row = $sth->fetchrow_array) {
						if ($Row[0]) {$Msg = "This account already exists. Please choose another Account ID";}
			}
			$sth->finish;
	}

	if ($Msg) {
			$Out =&Msgs("Missing Information", $Msg, 1);
			&Print_Page($Out, "Banner Manager", $Help);
			return;
	}

	$Param{Email} =~ s/^\s+//g;
	$Param{Email} =~ s/\s+$//g;

	$Param{Name} =~ s/^\s+//g;
	$Param{Name} =~ s/\s+$//g;

	$Param{Company} =~ s/^\s+//;
	$Param{Company} =~ s/\s+$//;

	$Param{Street} =~ s/^\s+//;
	$Param{Street} =~ s/\s+$//;

	$Param{City} =~ s/^\s+//;
	$Param{City} =~ s/\s+$//;

	$Param{State} =~ s/^\s+//;
	$Param{State} =~ s/\s+$//;

	$Param{Zip} =~ s/^\s+//;
	$Param{Zip} =~ s/\s+$//;

	$Param{Country} =~ s/^\s+//;
	$Param{Country} =~ s/\s+$//;

	$Param{Phone} =~ s/^\s+//;
	$Param{Phone} =~ s/\s+$//;

	$Param{Fax} =~ s/^\s+//;
	$Param{Fax} =~ s/\s+$//;

	$Param{Comments} =~ s/^\s+//;
	$Param{Comments} =~ s/\s+$//;

	$Param{Password} = $dbh->quote($Param{Password});
	$Param{Email} = $dbh->quote($Param{Email});
	$Param{Name} = $dbh->quote($Param{Name});
	$Param{Company} = $dbh->quote($Param{Company});
	$Param{Street} = $dbh->quote($Param{Street});
	$Param{City} = $dbh->quote($Param{City});
	$Param{State} = $dbh->quote($Param{State});
	$Param{Zip} = $dbh->quote($Param{Zip});
	$Param{Country} =$dbh->quote($Param{Country});
	$Param{Phone} = $dbh->quote($Param{Phone});
	$Param{Fax} = $dbh->quote($Param{Fax});
	$Param{Comments} = $dbh->quote($Param{Comments});
	
	if (!$Param{Edit_Account}) {
			$Param{Status} = 1;
			$Param{Start_Date} =$dbh->quote(&Time(time));

			$Query = qq!INSERT INTO Banner_Accounts 
								VALUES(
													$Param{Account},
													$Param{Password},
													$Param{Email},
													$Param{Name},
													$Param{Company},
													$Param{Street},
													$Param{City},
													$Param{State},
													$Param{Zip},
													$Param{Country},
													$Param{Phone},
													$Param{Fax},
													$Param{Status},
													$Param{Start_Date},
													$Param{Comments}
								)!;

				$Out =&Msgs("New Banner Account", "The new banner account <B>$Param{Account}</B> has been created and enabled.", 2);
	}
	else{
				$Param{Edit_Account} = $dbh->quote($Param{Edit_Account});
				$Query = qq!UPDATE Banner_Accounts  SET 
													Account=$Param{Edit_Account},
													Password=$Param{Password},
													Email=$Param{Email},
													Name=$Param{Name},
													Company=$Param{Company},
													Street=$Param{Street},
													City=$Param{City},
													State=$Param{State},
													Zip=$Param{Zip},
													Country=$Param{Country},
													Phone=$Param{Phone},
													Fax=$Param{Fax},
													Comments=$Param{Comments}
								!;
			$Out =&Msgs("Banner Account Saved", "The changes to the banner account <B>$Param{Edit_Account}</B> has been saved.", 2);							
	}

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);		
	$sth->finish;
	
	&Print_Page($Out, "Banner Manager", $Help);
						
}
#==========================================================
sub Edit_Banner_Account{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Account_Form($Param{Account}), "Edit Banner Account", $Help);
}
#==========================================================
sub Manage_Banner_Accounts{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Manage_Banner_Accounts_Form, "Banner Manager", $Help);
}
#==========================================================
sub Manage_Banner_Accounts_Form{
my($Out);
my($Query, $sth);

	$Query = qq!SELECT Account, Status FROM Banner_Accounts ORDER BY Account ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Account, $Status) = $sth->fetchrow_array) {
			push @Accounts, $Account;
			$Accounts{$Account} = $Status;
	}

	$sth->finish;
	#------------------------------------------------------
	undef %Count;
	$Query = qq!SELECT Account, COUNT(Campaign) FROM Banner_Campaigns GROUP BY Account!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Account, $Count) = $sth->fetchrow_array) {
			$Count{$Account} = $Count;
	}

	$sth->finish;
	#------------------------------------------------------
	if (!$Param{Page}) {$Param{Page} = 1;}

	$Total_Count = @Accounts;
	$Last_Page = int ($Total_Count / 10);
	if (($Total_Count % 10)) { $Last_Page++; }
	$Current_Page = $Param{Page};
	$Next_Page = $Current_Page + 1;
	$Previous_Page = $Current_Page - 1;
	if ($Next_Page > $Last_Page) {$Next_Page = $Last_Page;}
	$Next_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Zones&Page=$Next_Page">Next Page</A>!;
	$Previous_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Zones&Page=$Previous_Page">Previous Page</A>!;

	$Start = ($Current_Page - 1) * 10;
	$End = $Start + 10;
	if ($End > $Total_Count) {$End = $Total_Count;}

	if ($Current_Page == $Last_Page || $Total_Count <= 0) {
			$Next_Page = "Next Page";
	}
	else{
			$Next_Page = $Next_Page_Link;
	}

	if ($Current_Page == 1) {
			$Previous_Page = "Previous Page";
	}
	else{
			$Previous_Page = $Previous_Page_Link;
	}

	$Accounts = "";
	for $Count($Start..$End-1) {
		$x = $Count+1;
		$Temp = $Accounts[$Count];
		$Account = &Web_Encode($Accounts[$Count]);
		if ($Accounts{$Account}) {
				$Status = qq!<A HREF="$Script_URL?action=Change_Banner_Account_Status&Account=$Account&Status=Enabled&Page=$Param{Page}">Enabled</A>!;
		}
		else{
				$Status = qq!<A HREF="$Script_URL?action=Change_Banner_Account_Status&Account=$Account&Status=Disabled&Page=$Param{Page}">Disabled</A>!;
		}

		$Campaigns = qq!<A HREF="$Script_URL?action=Manage_Banner_Account_Campaigns&Account=$Account">$Count{$Account}</A>!;
		if (!$Count{$Account}) {$Campaigns ="None";}

		$Delete = qq~<A HREF="#" onClick="Delete_Banner_Account_Confirm(\'$Account\', \'$Temp\'); return false;">Delete</A>~;

		$Account = qq!<A HREF="$Script_URL?action=Edit_Banner_Account&Account=$Account">$Account</A>!;

		$Accounts .=qq!
		  <TR>
			<TD ALIGN="center" WIDTH="10%">&nbsp;$x</TD>
			<TD ALIGN="center" WIDTH="30%">&nbsp;$Account</TD>
			<TD ALIGN="center" WIDTH="30%">&nbsp;$Campaigns</TD>
			<TD ALIGN="center" WIDTH="15%">&nbsp;$Status</TD>
			<TD ALIGN="center" WIDTH="15%">&nbsp;$Delete</TD>
		  </TR>
		!;

	}

$Out =<<HTML;
  <DIV ALIGN="center">
    <CENTER>
    <TABLE BORDER="1" CELLSPACING="0" CELLPADDING="5" WIDTH="90%" $Global{Admin_Table_Attr}>
      <TR>
        <TD WIDTH="500%" ALIGN="center" BGCOLOR="#E7E7CF" COLSPAN="5"><FONT SIZE="4"><B>Manage
          Banner Accounts</B></FONT></TD>
      </TR>
      <TR>
        <TD ALIGN="center" WIDTH="10%"><B>#</B></TD>
        <TD ALIGN="center" WIDTH="30%"><B>Account</B></TD>
        <TD ALIGN="center" WIDTH="30%"><B>Campaigns</B></TD>
        <TD ALIGN="center" WIDTH="15%" COLSPAN="2"><B>Action</B></TD>
      </TR>

		$Accounts

		<TR>
        <TD ALIGN="center" COLSPAN="5">
			<INPUT TYPE="button" VALUE="Cancel" ONCLICK="history.go(-1)" STYLE="color: #000080; border-style: ridge"></TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
  <INPUT TYPE="hidden" NAME="action" VALUE="Save_New_Banner_Account">
</FORM>

<SCRIPT LANGUAGE="JavaScript">
<!--
function Delete_Banner_Account_Confirm(Account_Encoded, Account) {
	var agree=confirm("Are you sure you want to Delete the banner Account ["+Account+"] and all its campaigns\\n");
	if (agree){
				window.location = "$Script_URL?action=Delete_Banner_Account&Account=" +Account_Encoded;
	}
}
-->
</SCRIPT>
HTML
	return $Out;
}
#==========================================================
sub Delete_Banner_Account{
my($Query);

	$Param{Account} = $dbh->quote($Param{Account});
	$Query = qq!DELETE FROM Banner_Accounts WHERE Account=$Param{Account}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Accounts;
}
#==========================================================
sub Change_Banner_Account_Status{

	$Status = 1;
	if ($Param{Status} eq "Enabled") {$Status = 0;}
	
	$Param{Account} = $dbh->quote($Param{Account});
	$Query = qq!UPDATE Banner_Accounts SET Status = $Status WHERE Account=$Param{Account}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Accounts;
}
#==========================================================
sub Add_New_Banner_Campaign{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Campaign_Form(""), "Create New Banner Campaign", $Help);
}
#==========================================================
sub Banner_Campaign_Form{
my($Campaign) = @_;
my($Out, $Temp, $Temp1, $Accounts_Menu);
my($Selected, $Target_Tag_Menu);
my($Query, $sth);
	
	undef %Campaign;
	#------------------------------------------------------
	if ($Campaign) {
			$Campaign = $dbh->quote($Campaign);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Campaign!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Campaign = undef;
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
			$sth->finish;

			$Temp = $Campaign{Banner_URL};
			$Temp =~ s|^http://||;

			$Banner = "";
			if ($Temp){
					$Banner .= qq!<BR><P ALIGN="center"><IMG SRC="$Campaign{Banner_URL}" BORDER="0">!;
			}
			
			if ($Campaign{Text_Banner}){
					$Banner .= "<BR>$Campaign{Text_Banner}<BR>";
			}
	}
	else{
			$Banner = "";
	}
	#------------------------------------------------------	
	$Query = qq!SELECT Account FROM Banner_Accounts ORDER BY Account ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Accounts_Menu = "";
	while(($Account) = $sth->fetchrow_array) {
			$Temp = &Web_Encode($Account);
			$Temp1 = "";
			if ($Account eq $Campaign{Account}) {$Temp1 = "SELECTED";}
			$Accounts_Menu .= qq!<OPTION VALUE="$Temp" $Temp1>&nbsp;&nbsp; $Account &nbsp;&nbsp;!;
	}

	$sth->finish;
	#------------------------------------------------------	
	$Selected = "";
	if (!$Campaign{Target_Tag}) {$Selected = "SELECTED";}
	$Target_Tag_Menu = qq!<OPTION VALUE="" $Selected>Page Default!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_self") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION VALUE="_self" $Selected>Same Frame!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_top") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION VALUE="_top" $Selected>Whole Page!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_blank") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION VALUE="_blank" $Selected>New Window!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_parent") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION VALUE="_parent" $Selected>Parent Frame!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "new") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION VALUE="new" $Selected>Reuse New Window!;
	#------------------------------------------------------
	$Day = ""; $Month = ""; $Year = "";
	if ($Campaign{Start_Date}) {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++
	}

	$Day1 = ""; $Month1 = ""; $Year1 = "";
	if ($Campaign{End_Date}) {
					($Day1, $Month1, $Year1) = (localtime($Campaign{End_Date}))[3..5];	
					$Year1 += 1900;
					$Month1++;
	}
	#------------------------------------------------------
	$Clicks = "";
	$Impressions = "";
	$Time_Period = "";
	if ($Campaign{Type} eq "Clicks"){$Clicks = "CHECKED";}
	if ($Campaign{Type} eq "Impressions"){$Impressions = "CHECKED";}
	if ($Campaign{Type} eq "Time Period"){$Time_Period = "CHECKED";}
	#------------------------------------------------------
	if (!$Campaign{Max_Impressions}) {$Campaign{Max_Impressions} = "";	}
	if (!$Campaign{Max_Clicks}) {$Campaign{Max_Clicks} = "";}
	if (!$Campaign{Width}) {$Campaign{Width} = "";}
	if (!$Campaign{Height}) {$Campaign{Height} = "";}
	if (!$Campaign{Under_Text}) {$Campaign{Under_Text} = "";}
	if (!$Campaign{ALT_Text}) {$Campaign{ALT_Text} = "";}
	if (!$Campaign{Redirect_URL}) {$Campaign{Redirect_URL} = "";}
	if (!$Campaign{Banner_URL}) {$Campaign{Banner_URL} = "";}
	if (!$Campaign{Text_Banner}) {$Campaign{Text_Banner} = "";}
	#------------------------------------------------------
$Out =<<HTML;
<FORM METHOD="POST" ACTION="$Script_URL">
  <INPUT TYPE="hidden" NAME="action" VALUE="Save_Banner_Campaign">
  <DIV ALIGN="center">
    <CENTER>
    <TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4" WIDTH="100%" $Global{Admin_Table_Attr}>
      <TR>
        <TD NOWRAP>Account :</TD>
        <TD WIDTH="100%" NOWRAP>
	
	<SELECT SIZE="1" NAME="Account">
		$Accounts_Menu
          </SELECT>			

		</TD>
      </TR>
      <TR>
        <TD NOWRAP>Campaign Name:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT NAME="Campaign"  VALUE="$Campaign{Campaign}" SIZE="20"></TD>
      </TR>
      <TR>
        <TD NOWRAP VALIGN="top">Campaign Type:</TD>
        <TD WIDTH="100%" NOWRAP>

          <TABLE BORDER="0" CELLSPACING="0" CELLPADDING="9" >
            <TR>
              <TD NOWRAP><INPUT TYPE="radio" VALUE="Clicks" NAME="Type" $Clicks >Number of
                clicks</TD>
              <TD><INPUT TYPE="text" NAME="Max_Clicks" VALUE="$Campaign{Max_Clicks}" SIZE="20"> Clicks allowed</TD>
            </TR>	
            <TR>
              <TD NOWRAP><INPUT TYPE="radio" NAME="Type" VALUE="Impressions" $Impressions>Number of
                impressions</TD>
              <TD><INPUT TYPE="text" NAME="Max_Impressions"  VALUE="$Campaign{Max_Impressions}"  SIZE="20"> Impressions allowed</TD>
            </TR>
            <TR>
              <TD VALIGN="top" NOWRAP>
			<INPUT TYPE="radio" NAME="Type" VALUE="Time Period" $Time_Period>Number of days</TD>
              <TD>
                <TABLE BORDER="0">
                  <TR>
                    <TD>Start Date:</TD>
                    <TD><INPUT TYPE="text" NAME="Month" VALUE="$Month" SIZE="3">/<INPUT TYPE="text" NAME="Day" VALUE="$Day" SIZE="3">/<INPUT TYPE="text" NAME="Year" Value="$Year" SIZE="3">(mm/dd/yyyy)</TD>
                  </TR>
                  <TR>
                    <TD>End Date: </TD>
                    <TD><INPUT TYPE="text" NAME="Month1" VALUE="$Month1" SIZE="3">/<INPUT TYPE="text" NAME="Day1"  VALUE="$Day1" SIZE="3">/<INPUT TYPE="text" NAME="Year1" Value="$Year1" SIZE="3">(mm/dd/yyyy)</TD>
                  </TR>
                </TABLE>
              </TD>
            </TR>
          </TABLE>
        </TD>
      </TR>
      <TR>
        <TD NOWRAP>Size:</TD>
        <TD WIDTH="100%" NOWRAP>Width: <INPUT TYPE="text" NAME="Width"  VALUE="$Campaign{Width}" SIZE="10">&nbsp;&nbsp;&nbsp;&nbsp;
          Height: <INPUT TYPE="text" NAME="Height"  VALUE="$Campaign{Height}"  SIZE="10"></TD>
      </TR>
      <TR>
        <TD NOWRAP>Target:</TD>
        <TD WIDTH="100%" NOWRAP>
				<SELECT NAME="Target_Tag">
					$Target_Tag_Menu
				</SELECT>			  
		  </TD>
      </TR>
      <TR>
        <TD NOWRAP>Redirect URL:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Redirect_URL" VALUE="$Campaign{Redirect_URL}" SIZE="60"></TD>
      </TR>
      <TR>
        <TD NOWRAP>Under Text:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="Under_Text"  VALUE="$Campaign{Under_Text}" SIZE="60"></TD>
      </TR>
      <TR>
        <TD NOWRAP>Alt Text:</TD>
        <TD WIDTH="100%" NOWRAP><INPUT TYPE="text" NAME="ALT_Text"  VALUE="$Campaign{ALT_Text}" SIZE="60"></TD>
      </TR>
      <TR>
        <TD NOWRAP>Banner URL:</TD>
        <TD WIDTH="100%" NOWRAP>
			  <INPUT TYPE="text" NAME="Banner_URL"  VALUE="$Campaign{Banner_URL}" SIZE="60">
			$Banner
		  </TD>
      </TR>
      <TR>
        <TD VALIGN="top" NOWRAP>HTML Banner:</TD>
        <TD WIDTH="100%">
			  <TEXTAREA ROWS="7" NAME="Text_Banner" COLS="50">$Campaign{Text_Banner}</TEXTAREA><BR>
				Please use the class &lt;!--Click_Track--&gt; in your HREF of the clickable URL's inside your 
				html banner code.<BR>For example, &lt;A HREF="&lt;!--Click_Track--&gt;" &lt;!--TARGET--&gt;&gt; Click Here&lt;/A&gt;.
		  </TD>
      </TR>
      <TR>
        <TD COLSPAN="2" ALIGN="center"><INPUT TYPE="submit" VALUE="Submit" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_Banner_Campaign{
my($Msg, $Temp, @Row, $Found);
my($Query, $sth);

	if (!$Param{Account}){$Msg ="Please choose account for the campaign.<br>";}
	if (!$Param{Campaign}){$Msg .="Please enter a campaign name.<br>";}
	if (!$Param{Redirect_URL}){$Msg .="Please enter a Redirect URL.<br>";}
	if (!$Param{Width}){$Msg .="Please enter the banner width.<br>";}
	if (!$Param{Height}){$Msg .="Please enter the banner height.<br>";}
	if (!$Param{Type}){$Msg .="Please select the campaign type.<br>";}

	$Param{Banner_URL} =~ s/^\s+//;
	$Param{Banner_URL} =~ s/\s+$//;
	$Temp = $Param{Banner_URL};
	$Temp =~ s|^http:://||i;
	if (!$Temp) {$Param{Banner_URL} = "";}

	$Param{Text_Banner} =~ s/^\s+//;
	$Param{Text_Banner} =~ s/\s+$//;
	
	if (!$Param{Banner_URL} && !$Param{Text_Banner}) {
			$Msg .= "Please enter a banner image URL or a text banner code.<BR>";
	}

	if ($Msg) {
			$Out =&Msgs("Missing Information", $Msg, 1);
			&Print_Page($Out, "Banner Manager", $Help);
			return;
	}

	if ($Param{Type} eq "Time Period") {
			$Start_Date = timelocal(0, 0, 0, $Param{Day}, $Param{Month} - 1, $Param{Year} - 1900);
			$End_Date = timelocal(0, 0, 0, $Param{Day1}, $Param{Month1} - 1, $Param{Year1} - 1900);
			$Param{Start_Date} = $Start_Date;
			$Param{End_Date} = $End_Date;
	}
	else{
			$Param{Start_Date} = "";
			$Param{End_Date} = "";
	}

	$Param{Account} =  $dbh->quote($Param{Account});
	$Param{Campaign} = $dbh->quote($Param{Campaign});
	$Param{Target_Tag} = $dbh->quote($Param{Target_Tag});
	$Param{Redirect_URL} = $dbh->quote($Param{Redirect_URL});
	$Param{Under_Text} = $dbh->quote($Param{Under_Text});
	$Param{ALT_Text} = $dbh->quote($Param{ALT_Text});
	$Param{Banner_URL} = $dbh->quote($Param{Banner_URL});
	$Param{Text_Banner} = $dbh->quote($Param{Text_Banner});
	if (!$Param{Width}) {$Param{Width} = 468;}
	if (!$Param{Height}) {$Param{Height} = 60;}
	$Param{Type} = $dbh->quote($Param{Type});
	if (!$Param{Max_Clicks}) {$Param{Max_Clicks} = 0;}
	if (!$Param{Max_Impressions}) {$Param{Max_Impressions} = 0;}
	if (!$Param{Start_Date}) {$Param{Start_Date} = time;}
	if (!$Param{End_Date}) {$Param{End_Date} = 0;}

	$Query = qq!SELECT count(*) FROM Banner_Campaigns WHERE Campaign=$Param{Campaign}!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while (@Row = $sth->fetchrow_array){$Found = $Row[0];}
	$sth->finish;

	if ($Found) {
			#if ($Param{Max_Clicks} > $Campaign{Clicks}) {Campaign{Status} = 1;}
			$Query = qq!UPDATE Banner_Campaigns SET 
											Account=$Param{Account},
											Campaign=$Param{Campaign},
											Target_Tag=$Param{Target_Tag},
											Redirect_URL=$Param{Redirect_URL},
											Under_Text=$Param{Under_Text},
											ALT_Text=$Param{ALT_Text},
											Banner_URL=$Param{Banner_URL},
											Text_Banner=$Param{Text_Banner},
											Width=$Param{Width},
											Height=$Param{Height},
											Type=$Param{Type},
											Max_Clicks=$Param{Max_Clicks},
											Max_Impressions=$Param{Max_Impressions},
											Start_Date=$Param{Start_Date},
											End_Date=$Param{End_Date}
								WHERE  Campaign=$Param{Campaign}
								!;
	}
	else{

			$Param{Clicks} = 0;
			$Param{Impressions} = 0;
			$Param{Status} = 1;

			$Query = qq!INSERT INTO Banner_Campaigns VALUES(
											$Param{Account},
											$Param{Campaign},
											$Param{Target_Tag},
											$Param{Redirect_URL},
											$Param{Under_Text},
											$Param{ALT_Text},
											$Param{Banner_URL},
											$Param{Text_Banner},
											$Param{Width},
											$Param{Height},
											$Param{Type},
											$Param{Clicks},
											$Param{Max_Clicks},
											$Param{Impressions},
											$Param{Max_Impressions},
											$Param{Start_Date},
											$Param{End_Date},
											$Param{Status}
								)!;
	}

	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Out =&Msgs("Campaign Saved", "The campaign $Param{Campaign} has been saved.", 2);
	&Print_Page($Out, "Banner Manager", $Help);
	
}
#==========================================================
sub Manage_Banner_Campaigns{
my ($Help);

	$Help = &Help_Link("Manage_Zones");
	&Print_Page(&Manage_Banner_Campaigns_Form, "Manage Banner Campaigns", $Help);	
}
#==========================================================
sub Manage_Banner_Campaigns_Form{
my($Out, $Form, $Count, $Table);
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth, %Campaign);

	$Query = qq!SELECT Campaign FROM Banner_Campaigns ORDER BY Campaign!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {
				push @Campaigns, $Row[0];
	}
	$sth->finish;

	if (!$Param{Page}) {$Param{Page} = 1;}

	$Total_Count = @Campaigns;
	$Last_Page = int ($Total_Count / 10);
	if (($Total_Count % 10)) { $Last_Page++; }
	$Current_Page = $Param{Page};
	$Next_Page = $Current_Page + 1;
	$Previous_Page = $Current_Page - 1;
	if ($Next_Page > $Last_Page) {$Next_Page = $Last_Page;}

	$Next_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Campaigns&Page=$Next_Page">Next Page</A>!;
	$Previous_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Campaigns&Page=$Previous_Page">Previous Page</A>!;

	$Start = ($Current_Page - 1) * 10;
	$End = $Start + 10;
	if ($End > $Total_Count) {$End = $Total_Count;}

	if ($Current_Page == $Last_Page || $Total_Count <= 0) {
			$Next_Page = "Next Page";
	}
	else{
			$Next_Page = $Next_Page_Link;
	}

	if ($Current_Page == 1) {
			$Previous_Page = "Previous Page";
	}
	else{
			$Previous_Page = $Previous_Page_Link;
	}

	$Table = "";
	for $Count($Start..$End-1) {
			$x = $Count+1;
			undef %Campaign;
			$Temp = $dbh->quote($Campaigns[$Count]);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Temp!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp}};
			$sth->finish;

			$Temp = &Web_Encode($Campaign{Campaign});
			$Campaign_Name = qq!<A HREF="$Script_URL?action=Edit_Banner_Campaign&Campaign=$Temp"><FONT SIZE="-1">$Campaign{Campaign}</FONT></A>!;
			$Edit = qq!<A HREF="$Script_URL?action=Edit_Banner_Campaign&Campaign=$Temp"><FONT SIZE="-1">Edit</FONT></A>!;

			$Temp = &Web_Encode($Campaign{Account});
			$Account = qq!<A HREF="$Script_URL?action=Edit_Banner_Account&Account=$Temp"><FONT SIZE="-1">$Campaign{Account}</FONT></A>!;
			
			$Progress = "";
			if ($Campaign{Type} eq "Clicks") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Clicks}) {
							$Progress = int (($Campaign{Clicks} / $Campaign{Max_Clicks}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Impressions") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Impressions}) {
							$Progress = int (($Campaign{Impressions} / $Campaign{Max_Impressions}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Time Period") {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Startd = timelocal(0, 0, 0, $Day, $Month, $Year);

					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$Start_Date = "$Month/$Day/$Year";
					
					($Day, $Month, $Year) = (localtime($Campaign{End_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$End_Date = "$Month/$Day/$Year";	
					
					($Day, $Month, $Year) = (localtime(time))[3..5];
					$Today = timelocal(0, 0, 0, $Day, $Month, $Year);

					if ($Campaign{End_Date}) {
							if (($Campaign{End_Date}-$Startd) == 0) {
									$Progress = "100%";
							}
							else{
									$Progress = int ((($Today-$Startd) / ($Campaign{End_Date}-$Startd)) * 100) . "%";
							}
					}
			}
			else{
					$Start_Date = " ";
					$End_Date = " ";
			}
			
			$Precentage = " ";
			if ($Campaign{Impressions}) {
						$Precentage = (($Campaign{Clicks} / $Campaign{Impressions}) *100 );
						$Precentage = sprintf("%2.2f\%",$Precentage);
			}

			$Temp = &Web_Encode($Campaign{Campaign});

			if ($Campaign{Status}){
					$Status = qq!<A HREF="$Script_URL?action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Enabled&Page=$Param{Page}"><FONT SIZE="-2">&nbsp;Active&nbsp;</FONT></A>!;
			}
			else{
					$Status = qq!<A HREF="$Script_URL?action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Disabled&Page=$Param{Page}"><FONT SIZE="-2">Inactive</FONT></A>!;
			}

			$Delete = qq!<A HREF="#" onClick="Delete_Banner_Campaign_Confirm(\'$Campaign{Campaign}\', \'$Temp\'); return false;"><FONT SIZE="-2">Delete</FONT></A>!;		
			$Config = qq!<A HREF="$Script_URL?action=Configure_Banner_Campaign&Campaign=$Campaign{Campaign}"><FONT SIZE="-2">Config</FONT></A>!;
			$Temp = &Web_Encode($Campaign{Account});
			$Stats = qq!<A HREF="$Script_URL?action=List_Advertiser_Campaigns&Account=$Temp&Advertiser_User_ID=$Temp&AdminFlag=1&Campaign=$Campaign{Campaign}"><FONT SIZE="-2">Stats</FONT></A>!;
			#$Code  = qq!<A HREF="$Script_URL?action=Admin_Banner_Campaign_Stats&Campaign=$Campaign{Campaign}"><FONT SIZE="-2">Code</FONT></A>!;
$Form =<<HTML;
    <TR>
      <TD ALIGN="center">$Campaign_Name</TD>
      <TD ALIGN="center">$Account</TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Campaign{Clicks}</FONT></TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Campaign{Impressions}</FONT></TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Precentage</FONT></TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Progress</FONT></TD>
       <TD ALIGN="center"  >
        <TABLE BORDER="0" WIDTH="100%" CELLPADDING="2" CELLSPACING="0">
          <TR>
            <TD ALIGN="center" NOWARP>$Config</TD>
            <TD ALIGN="center" NOWARP>$Status</TD>
            <TD ALIGN="center" NOWARP>$Delete</TD>
            <TD ALIGN="center" NOWARP>$Stats</TD>
          </TR>
        </TABLE>
	</TD>
	</TR>

HTML

			$Table .= $Form;
	}
	
	$sth->finish;

	$Start++;

$Out=<<HTML;
<DIV ALIGN="center"> <CENTER>
  <TABLE BORDER="01" WIDTH="100%" CELLSPACING="0" CELLPADDING="3" $Global{Admin_Table_Attr}>
    <TR>
      <TD WIDTH="25%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Campaign</B></TD>
      <TD WIDTH="20%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Account</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Clicks</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Impr</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>CTR</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Spent</B></TD>
      <TD WIDTH="25%" BGCOLOR="#E7E7CF" ALIGN="center" NOWARP><B>Action</B></TD>
    </TR>

$Table

</TABLE>
  </CENTER>
</DIV>
<P ALIGN="right">Showing $Start - $End of $Total_Count totals &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$Previous_Page &nbsp;&nbsp; $Next_Page	&nbsp;&nbsp;&nbsp;</P>

<SCRIPT LANGUAGE="JavaScript">
<!--
function Delete_Banner_Campaign_Confirm(Campaign_Encoded, Campaign) {
	var agree=confirm("Are you sure you want to Delete the banner Campaign ["+Campaign+"] \\n");
	if (agree){
			var agree=confirm("Please note once the Campaign deleted, all its logs and statistics also will be deleted\\nAre you sure you still want to delete the banner Campaign ["+Campaign+"]\\n");
			if (agree){
				window.location = "$Script_URL?action=Delete_Banner_Campaign&Campaign=" +Campaign_Encoded;
			}
	}
}
-->
</SCRIPT>
HTML
	
	return $Out;

}
#==========================================================
sub Manage_Banner_Account_Campaigns{
my ($Help);

	$Help = &Help_Link("Manage_Banner_Account_Campaigns");
	&Print_Page(&Manage_Banner_Account_Campaigns_Form, "Manage Banner Account Campaigns", $Help);	
}
#==========================================================
sub Manage_Banner_Account_Campaigns_Form{
my($Out, $Form, $Count, $Table);
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth, %Campaign);

	$Account = $dbh->quote($Param{Account});
	$Query = qq!SELECT Campaign FROM Banner_Campaigns Where Account=$Account ORDER BY Campaign!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {
				push @Campaigns, $Row[0];
	}
	$sth->finish;

	if (!$Param{Page}) {$Param{Page} = 1;}

	$Total_Count = @Campaigns;
	$Last_Page = int ($Total_Count / 10);
	if (($Total_Count % 10)) { $Last_Page++; }
	$Current_Page = $Param{Page};
	$Next_Page = $Current_Page + 1;
	$Previous_Page = $Current_Page - 1;
	if ($Next_Page > $Last_Page) {$Next_Page = $Last_Page;}

	$Next_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Campaigns&Page=$Next_Page">Next Page</A>!;
	$Previous_Page_Link = qq!<A HREF="$Script_URL?action=Manage_Banner_Campaigns&Page=$Previous_Page">Previous Page</A>!;

	$Start = ($Current_Page - 1) * 10;
	$End = $Start + 10;
	if ($End > $Total_Count) {$End = $Total_Count;}

	if ($Current_Page == $Last_Page || $Total_Count <= 0) {
			$Next_Page = "Next Page";
	}
	else{
			$Next_Page = $Next_Page_Link;
	}

	if ($Current_Page == 1) {
			$Previous_Page = "Previous Page";
	}
	else{
			$Previous_Page = $Previous_Page_Link;
	}

	$Table = "";
	for $Count($Start..$End-1) {
			$x = $Count+1;
			undef %Campaign;
			$Temp = $dbh->quote($Campaigns[$Count]);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Temp!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp}};
			$sth->finish;

			$Temp = &Web_Encode($Campaign{Campaign});
			$Campaign_Name = qq!<A HREF="$Script_URL?action=Edit_Banner_Campaign&Campaign=$Temp"><FONT SIZE="-1">$Campaign{Campaign}</FONT></A>!;
			$Edit = qq!<A HREF="$Script_URL?action=Edit_Banner_Campaign&Campaign=$Temp"><FONT SIZE="-1">Edit</FONT></A>!;

			$Temp = &Web_Encode($Campaign{Account});
			$Account = qq!<A HREF="$Script_URL?action=Edit_Banner_Account&Account=$Temp"><FONT SIZE="-1">$Campaign{Account}</FONT></A>!;
			
			$Progress = "";
			if ($Campaign{Type} eq "Clicks") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Clicks}) {
							$Progress = int (($Campaign{Clicks} / $Campaign{Max_Clicks}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Impressions") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Impressions}) {
							$Progress = int (($Campaign{Impressions} / $Campaign{Max_Impressions}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Time Period") {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Startd = timelocal(0, 0, 0, $Day, $Month, $Year);

					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$Start_Date = "$Month/$Day/$Year";
					
					($Day, $Month, $Year) = (localtime($Campaign{End_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$End_Date = "$Month/$Day/$Year";	
					
					($Day, $Month, $Year) = (localtime(time))[3..5];
					$Today = timelocal(0, 0, 0, $Day, $Month, $Year);

					if ($Campaign{End_Date}) {
							$Progress = int ((($Today-$Startd) / ($Campaign{End_Date}-$Startd)) * 100) . "%";
					}
			}
			else{
					$Start_Date = " ";
					$End_Date = " ";
			}
			
			$Precentage = " ";
			if ($Campaign{Impressions}) {
						$Precentage = (($Campaign{Clicks} / $Campaign{Impressions}) *100 );
						$Precentage = sprintf("%2.2f\%",$Precentage);
			}

			$Temp = &Web_Encode($Campaign{Campaign});

			if ($Campaign{Status}){
					$Status = qq!<A HREF="$Script_URL?action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Enabled&Page=$Param{Page}"><FONT SIZE="-2">&nbsp;Active&nbsp;</FONT></A>!;
			}
			else{
					$Status = qq!<A HREF="$Script_URL?action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Disabled&Page=$Param{Page}"><FONT SIZE="-2">Inactive</FONT></A>!;
			}

			$Delete = qq!<A HREF="#" onClick="Delete_Banner_Campaign_Confirm(\'$Campaign{Campaign}\', \'$Temp\'); return false;"><FONT SIZE="-2">Delete</FONT></A>!;		
			$Config = qq!<A HREF="$Script_URL?action=Configure_Banner_Campaign&Campaign=$Campaign{Campaign}"><FONT SIZE="-2">Config</FONT></A>!;
			$Temp = &Web_Encode($Campaign{Account});
			$Stats = qq!<A HREF="$Script_URL?action=List_Advertiser_Campaigns&Account=$Temp&Advertiser_User_ID=$Temp&AdminFlag=1&Campaign=$Campaign{Campaign}"><FONT SIZE="-2">Stats</FONT></A>!;
			#$Code  = qq!<A HREF="$Script_URL?action=Admin_Banner_Campaign_Stats&Campaign=$Campaign{Campaign}"><FONT SIZE="-2">Code</FONT></A>!;
$Form =<<HTML;
    <TR>
      <TD ALIGN="center">$Campaign_Name</TD>
      <TD ALIGN="center">$Account</TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Campaign{Clicks}</FONT></TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Campaign{Impressions}</FONT></TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Precentage</FONT></TD>
      <TD ALIGN="center"><FONT SIZE="-1">$Progress</FONT></TD>
       <TD ALIGN="center"  >
        <TABLE BORDER="0" WIDTH="100%" CELLPADDING="2" CELLSPACING="0">
          <TR>
            <TD ALIGN="center" NOWARP>$Config</TD>
            <TD ALIGN="center" NOWARP>$Status</TD>
            <TD ALIGN="center" NOWARP>$Delete</TD>
            <TD ALIGN="center" NOWARP>$Stats</TD>
          </TR>
        </TABLE>
	</TD>
	</TR>

HTML

			$Table .= $Form;
	}
	
	$sth->finish;

	$Start++;

$Out=<<HTML;
<DIV ALIGN="center"> <CENTER>
  <TABLE BORDER="01" WIDTH="100%" CELLSPACING="0" CELLPADDING="3" $Global{Admin_Table_Attr}>
    <TR>
      <TD WIDTH="25%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Campaign</B></TD>
      <TD WIDTH="20%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Account</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Clicks</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Impr</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>CTR</B></TD>
      <TD WIDTH="7%" BGCOLOR="#E7E7CF" ALIGN="center"><B>Spent</B></TD>
      <TD WIDTH="25%" BGCOLOR="#E7E7CF" ALIGN="center" NOWARP><B>Action</B></TD>
    </TR>

$Table

</TABLE>
  </CENTER>
</DIV>
<P ALIGN="right">Showing $Start - $End of $Total_Count totals &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$Previous_Page &nbsp;&nbsp; $Next_Page	&nbsp;&nbsp;&nbsp;</P>

<SCRIPT LANGUAGE="JavaScript">
<!--
function Delete_Banner_Campaign_Confirm(Campaign_Encoded, Campaign) {
	var agree=confirm("Are you sure you want to Delete the banner Campaign ["+Campaign+"] \\n");
	if (agree){
			var agree=confirm("Please note once the Campaign deleted, all its logs and statistics also will be deleted\\nAre you sure you still want to delete the banner Campaign ["+Campaign+"]\\n");
			if (agree){
				window.location = "$Script_URL?action=Delete_Banner_Campaign&Campaign=" +Campaign_Encoded;
			}
	}
}
-->
</SCRIPT>
HTML
	
	return $Out;

}
#==========================================================
sub Change_Banner_Campaign_Status{
my($Status, $Query);

	$Status = 1;
	if ($Param{Status} eq "Enabled") {$Status = 0;}
	
	$Param{Campaign} = $dbh->quote($Param{Campaign});

	$Query = qq!UPDATE Banner_Campaigns SET Status = $Status WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!UPDATE Banners SET Status = $Status WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Campaigns;
}
#==========================================================
sub Delete_Banner_Campaign{
	
	$Param{Campaign} = $dbh->quote($Param{Campaign});		
	$Query = qq!DELETE FROM Banner_Campaigns WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Banners WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	# delete its logs and stats

	&Manage_Banner_Campaigns;
}
#==========================================================
sub Edit_Banner_Campaign{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Campaign_Form("$Param{Campaign}"), "Edit Banner Campaign", $Help);

}
#==========================================================
sub Configure_Banner_Campaign{
my ($Help);
			
	$Help = &Help_Link("Configure_Banner_Campaign");
	&Print_Page(&Configure_Banner_Campaign_Form("$Param{Campaign}"), "Configure Banner Campaign", $Help);
}
#==========================================================
sub Configure_Banner_Campaign_Form{
my($Campaign) = @_;
my($Out, $Temp);

	$Campaign_encoded = $dbh->quote($Campaign);

	$Query = qq!SELECT Zone FROM Banners WHERE Campaign=$Campaign_encoded ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	undef %Zones;
	while(($Zone) = $sth->fetchrow_array) {
			$Zones{$Zone} = 1;
	}
	$sth->finish;
	#-------------------
	$Query = qq!SELECT Zone FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Zone_Menu = "";
	while(($Zone) = $sth->fetchrow_array) {
			push @Zones, $Zone;
			$Temp = &Web_Encode($Zone);
			$Temp1 = "";
			if (exists $Zones{$Zone}) {$Temp1 = "SELECTED";}
			$Zone_Menu .= qq!<OPTION VALUE="$Temp" $Temp1>$Zone!;
	}
	$sth->finish;

$Out=<<HTML;
<P>Select the zones that the campaign will rotate in.</P>
<FORM METHOD="POST" ACTION="$Script_URL">
 <INPUT TYPE="hidden" NAME="action" VALUE="Save_Banner_Campaign_Configuration">
<INPUT TYPE="hidden" NAME="Campaign" VALUE="$Campaign_encoded">
<DIV ALIGN="center">
    <CENTER>
    <TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4" WIDTH="100%" $Global{Admin_Table_Attr}>
      <TR>
        <TD NOWRAP WIDTH="20%" VALIGN="top">Campaign:</TD>
        <TD WIDTH="80%">$Campaign</TD>
      </TR>
      <TR>
        <TD NOWRAP WIDTH="20%" VALIGN="top">Active Zones:</TD>
        <TD WIDTH="80%">
			To Select more than one zone from the list, drag your mouse or click with the &lt;CTRL&gt; Key pressed. <BR>
				<P ALIGN="center">
			<SELECT SIZE="8" NAME="Zones_Selected" MULTIPLE>
			<OPTION VALUE="">------    Select Campaign Rotation Zones    ------</OPTION>
			$Zone_Menu
          </SELECT>
			</P>

			 </TD>
      </TR>
      <TR>
        <TD ALIGN="center" HEIGHT="25" COLSPAN="2"><INPUT TYPE="submit" VALUE="Save Changes" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_Banner_Campaign_Configuration{

	$Campaign = $Param{Campaign};
	$Param{Campaign} = &Web_Decode($Param{Campaign});
	$Param{Zones_Selected} = &Web_Decode($Param{Zones_Selected});
	#print "Content-Type: text/html\n\n";
	#print "$Param{Zones_Selected}";
	@Zones = split(/\|\|/, $Param{Zones_Selected});

	$Query = qq!SELECT Status FROM Banner_Campaigns WHERE Campaign=$Campaign!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	while($Temp = $sth->fetchrow_array) {$Status = $Temp;}
	$sth->finish;

	$Query = qq!DELETE FROM Banners WHERE Campaign=$Campaign!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	foreach $Zone (@Zones) {
				$Zone = $dbh->quote($Zone);
				$Query = qq!INSERT INTO Banners VALUES($Param{Campaign}, $Zone, '$Status')!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);		
	}

	$sth->finish;
			
	$Out =&Msgs("Configuration Saved", "The campaign $Campaign zones configuration has been saved.", 2);
	&Print_Page($Out, "Banner Manager", $Help);
}
#==========================================================
sub Edit_Banner_Templates{
my ($Help);

	$Help = &Help_Link("Edit_Banner_Templates");
	&Print_Page(&Edit_Banner_Templates_Form, "Edit Banner Templates", $Help);

}
#==========================================================
sub Edit_Banner_Templates_Form{
my($Out, %Class, @Class, $Classes);
my($Class_Index, $Class, $x, $y);

	@Class = (
							'Banner_List_Campaigns_Table',
							'Banner_List_Campaigns_Row',
							'Banner_List_Campaigns_Row1',
							'Banner_Daily_Report_Table',
							'Banner_Daily_Report_Table_Row',
							'Banner_Daily_Report_Table_Row1',
							'Banner_Hourly_Report_Table',
							'Banner_Hourly_Report_Table_Row',
							'Banner_Hourly_Report_Table_Row1',
							'Banner_Click_Log_Table',
							'Banner_Click_Log_Table_Row',
							'Banner_Click_Log_Table_Row1'
					);

	%Class = (
						'Banner_List_Campaigns_Table'=>&Encode_HTML($Global{Banner_List_Campaigns_Table}),
						'Banner_List_Campaigns_Row'=>&Encode_HTML($Global{Banner_List_Campaigns_Row}),
						'Banner_List_Campaigns_Row1'=>&Encode_HTML($Global{Banner_List_Campaigns_Row1}),
						'Banner_Daily_Report_Table'=>&Encode_HTML($Global{Banner_Daily_Report_Table}),
						'Banner_Daily_Report_Table_Row'=>&Encode_HTML($Global{Banner_Daily_Report_Table_Row}),
						'Banner_Daily_Report_Table_Row1'=>&Encode_HTML($Global{Banner_Daily_Report_Table_Row1}),
						'Banner_Hourly_Report_Table'=>&Encode_HTML($Global{Banner_Hourly_Report_Table}),
						'Banner_Hourly_Report_Table_Row'=>&Encode_HTML($Global{Banner_Hourly_Report_Table_Row}),
						'Banner_Hourly_Report_Table_Row1'=>&Encode_HTML($Global{Banner_Hourly_Report_Table_Row1}),
						'Banner_Click_Log_Table'=>&Encode_HTML($Global{Banner_Click_Log_Table}),
						'Banner_Click_Log_Table_Row'=>&Encode_HTML($Global{Banner_Click_Log_Table_Row}),
						'Banner_Click_Log_Table_Row1'=>&Encode_HTML($Global{Banner_Click_Log_Table_Row1}),
						);

	$Class_Index = "";
	for $x(0..$#Class) {
			$y = $x+1;
			 $Class_Index .= qq!Class_Index[$y] = \'$Class[$x]\';\n!;
	}

	$Classes = qq! <SELECT NAME="Classes" onChange="Change_Class();"> <OPTION>--- Please Select Class ---!;
	foreach $Class(@Class) {
		$Classes .= qq!<OPTION VALUE="$Class{$Class}">$Class</OPTION>!;
	}
   $Classes .= qq!</SELECT>!;

$Out =<<HTML;
<DIV ALIGN="center">
<CENTER>
<FORM METHOD="POST" NAME ="Classes_Form" ACTION="$Script_URL">
<INPUT TYPE="hidden" NAME="action" VALUE="Save_Edit_Banner_Templates">
<INPUT TYPE="hidden" NAME="Class_Name" VALUE="">
<TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="2">
  <TR>
	<TD WIDTH="100%" ALIGN="center">
		$Classes
		<INPUT TYPE="submit" VALUE="Save Changes" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
	</TD>
  </TR>
  <TR><TD WIDTH="100%" ALIGN="center">
		<TEXTAREA ROWS="25" NAME="Class" cols="80" STYLE="border-style: groove"></textarea>
	</TD>
  </TR>
</TABLE>
</FORM>
<CENTER>
</DIV>

<SCRIPT LANGUAGE="JavaScript">
<!--
function Change_Class() {
var Class_Index = new Array(); 
$Class_Index

	if (!document.Classes_Form.Classes.selectedIndex) {return false;}
	document.Classes_Form.Class.value = document.Classes_Form.Classes[document.Classes_Form.Classes.selectedIndex].value;
	document.Classes_Form.Class_Name.value = ''+Class_Index[document.Classes_Form.Classes.selectedIndex];
}
// -->
</SCRIPT>

HTML

	$Out;
}
#==========================================================
sub Save_Edit_Banner_Templates{
my (%Config);

	undef %Config;

	if ($Param{Class_Name}){
			$Param{Class} =~ s/\cM//g;
			$Config{$Param{Class_Name}} = $Param{Class};
			&Update_Configuration(%Config);
	}
	
	#&Admin_Msg("Changes Saved", "<BR>Banner template <B> $Param{Class_Name}</B> successfully saved.<BR><BR>", 1);
	&Read_Configuration;
	&Edit_Banner_Templates;
}
#==========================================================
1;