=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Initialize_Program{

	$ENV{CONTENT_TYPE} ||="";
	if ($ENV{CONTENT_TYPE} =~ /multipart/) {
			&Get_Form_Multipart;
	}
	else {
			&Get_Form;
	};

	#&Get_Script_URL;
	&Get_Cookies;
	&Read_Configuration;
	srand (time | $$);

	if ($Global{TimeHiRes}) {
			$Global{Program_Start_Time} = Time::HiRes::gettimeofday();
	}
	else{
			$Global{Program_Start_Time} = time;
	}
}
#==========================================================
sub Read_Configuration_Files{
my (@All, $K, $V, $Line, %Update);
	
	open (FILE, "$Global{Configuration_File}") || &Exit("Cannot open configuration file $Global{Configuration_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	foreach $Line(@All){
			($K, $V) = split(/\~\=\=\~/ , $Line);
			$V =~ s/\n$//g;
			$V=~ s/\\n/\n/g;
			$Global{$K} = $V;
	}
	#------------------------------------
	open (FILE, "$Global{Data_File}") || &Exit("Cannot open configuration file $Global{Data_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	foreach $Line(@All){
			($K, $V) = split(/\~\=\=\~/ , $Line);
			$V =~ s/\n$//g;
			$V=~ s/\\n/\n/g;
			$Global{$K} = $V;
	}
	#------------------------------------
}
#==========================================================
sub Update_Configuration{
my (%Data) = @_;
my (@All, $Key, $Value, $Line, %Config);

	open (FILE, "$Global{Configuration_File}") || &Exit("Cannot read configuration file $Global{Configuration_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	
	undef %Config;

	foreach $Line(@All){
			$Line =~ s/\n$//;
			($Key, $Value) = split(/\~\=\=\~/ , $Line);
			$Value =~ s/\\n/\n/g;
			$Config{$Key} = $Value;
	}

	while (($Key, $Value) = each %Data) {
			$Config{$Key} = $Value;
	}

	if (!&Lock($Global{Configuration_File})) {&Exit("Cannot Lock file, server may be busy, please wait a few seconds and try again.<br> $Global{Configuration_File}: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);}
	open (FILE, ">$Global{Configuration_File}") || &Exit("Cannot write configuration file $Global{Configuration_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	
	while (($Key, $Value) = each(%Config)) {
			$Value  =~ s/\n/\\n/g;
			print FILE  "$Key~==~$Value\n";
	}

	close(FILE);

	&Unlock($Global{Configuration_File});
}
#==========================================================
sub Update_Data{
my (%Data) = @_;
my (@All, $Key, $Value, $Line, %Config);

	open (FILE, "$Global{Data_File}") || &Exit("Cannot read data file $Global{Data_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	
	undef %Config;

	foreach $Line(@All){
			$Line =~ s/\n$//;
			($Key, $Value) = split(/\~\=\=\~/ , $Line);
			$Value =~ s/\\n/\n/g;
			$Config{$Key} = $Value;
	}

	while (($Key, $Value) = each %Data) {
			$Config{$Key} = $Value;
	}

	if (!&Lock($Global{Data_File})) {&Exit("Cannot Lock file, server may be busy, please wait a few seconds and try again.<br> $Global{Data_File}: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);}
	open (FILE, ">$Global{Data_File}") || &Exit("Cannot write configuration file $Global{Data_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	
	while (($Key, $Value) = each(%Config)) {
			$Value  =~ s/\n/\\n/g;
			print FILE  "$Key~==~$Value\n";
	}

	close(FILE);

	&Unlock($Global{Data_File});
}
#==========================================================
sub  InitializeLanguagePaths{ 

	$Global{Language_Dir} = "$Global{Data_Dir}/language";
	$Global{Lang_Dir} = "$Global{Language_Dir}/$Global{Language}";

	$Global{Language_Forum_File} = "$Global{Lang_Dir}/Forum.pm";

	$Global{Language_Languages_File} = "$Global{Lang_Dir}/Languages.pm";
	$Global{Language_Register_File} = "$Global{Lang_Dir}/Register.pm";
	$Global{Language_EditProfile_File} = "$Global{Lang_Dir}/EditProfile.pm";
	$Global{Language_AccountManager_File} = "$Global{Lang_Dir}/AccountMgr.pm";
	$Global{Language_PrivMsgs_File} = "$Global{Lang_Dir}/PrivMsgs.pm";
	
	$Global{Language_Copyright_File} = "$Global{Lang_Dir}/Copyright.pm";
	$Global{Language_Terms_of_Use_File} = "$Global{Lang_Dir}/TermsOfUse.pm";
	$Global{Language_Privacy_Policy_File} = "$Global{Lang_Dir}/PrivacyPolicy.pm";

	$Global{Language_About_Us_File} = "$Global{Lang_Dir}/AboutUs.pm";
	$Global{Language_Advertise_File} = "$Global{Lang_Dir}/Advertise.pm";
	$Global{Language_ContactUs_File} = "$Global{Lang_Dir}/ContactUs.pm";

	$Global{Language_Set_Language_File} = "$Global{Lang_Dir}/SetLanguage.pm";
	$Global{Language_Search_Tips_File} = "$Global{Lang_Dir}/SearchTips.pm";
	$Global{Language_Custom_File} = "$Global{Lang_Dir}/Custom.pm";
	$Global{Language_Access_Lock_File} = "$Global{Lang_Dir}/AccessLock.pm";
	$Global{Language_Help_File} = "$Global{Lang_Dir}/Help.pm";
	$Global{Language_Banner_File} = "$Global{Lang_Dir}/Banner.pm";
	$Global{Countries_File} = "$Global{Lang_Dir}/Countries.pm";

	$Global{Language_Community_File} = "$Global{Lang_Dir}/Community.pm";
}
#==========================================================
sub InitializeTemplatesPaths{ 

	$Global{ForumHomepage_Template} =  "$Global{Template_Dir}/Homepage.html";
	$Global{ForumBrowse_Template} =  "$Global{Template_Dir}/ForumBrowse.html";
	$Global{ForumTopicsForm_Template} =  "$Global{Template_Dir}/TopicsForm.html";
	$Global{AllForums_Template} =  "$Global{Template_Dir}/ForumsTree.html";
	$Global{ForumMyPosts_Template} =  "$Global{Template_Dir}/MyPosts.html";
	$Global{ForumMyFavorites_Template} =  "$Global{Template_Dir}/MyFavorites.html";
	$Global{MyPreferences_Template} =  "$Global{Template_Dir}/MyPreferences.html";

	$Global{ForumTopicsList_Template} =  "$Global{Template_Dir}/TopicsList.html";
	$Global{ForumNewTopic_Template} =  "$Global{Template_Dir}/NewTopic.html";
	$Global{ForumViewTopic_Template} =  "$Global{Template_Dir}/ViewTopic.html";
	$Global{ForumTopicReview_Template} =  "$Global{Template_Dir}/TopicReview.html";
	
	$Global{ForumNewPost_Template} =  "$Global{Template_Dir}/NewPost.html";
	$Global{ForumEditPost_Template} =  "$Global{Template_Dir}/EditPost.html";
	$Global{ForumDeletePost_Template} =  "$Global{Template_Dir}/DeletePost.html";
	$Global{ForumViewIP_Template} =  "$Global{Template_Dir}/ViewIP.html";
	$Global{PreviewTopicForm_Template} =  "$Global{Template_Dir}/PreviewTopicForm.html";
	$Global{PreviewPostForm_Template} =  "$Global{Template_Dir}/PreviewPostForm.html";
	$Global{ForumSearchTopics_Template} =  "$Global{Template_Dir}/SearchTopics.html";
	$Global{ForumViewProfile_Template} =  "$Global{Template_Dir}/ViewProfile.html";
	$Global{ForumDeleteTopic_Template} =  "$Global{Template_Dir}/DeleteTopic.html";

	$Global{AboutMeEditor_Template} = "$Global{Template_Dir}/AboutMeEditor.html";
	$Global{AboutMe_Template} = "$Global{Template_Dir}/AboutMe.html";
	
	$Global{HtmlEditor_Template} =  "$Global{Template_Dir}/HtmlEditor.html";
	$Global{HtmlEditor_Template_Admin} =  "$Global{Template_Dir}/HtmlEditorAdmin.html";
	
	$Global{Register_Template} = "$Global{Template_Dir}/Register.html";
	$Global{EditProfile_Template} = "$Global{Template_Dir}/EditProfile.html";

	$Global{AccountManager_Template} = "$Global{Template_Dir}/AccountMgr.html";
	$Global{Account_Manager_Login_Template} = "$Global{Template_Dir}/AccountLoginForm.html";
	$Global{Account_Manager_Main_Template} = "$Global{Template_Dir}/AcctMgrOverview.html";

	#------------------------------------------------------
	# private messaging templates
	$Global{MyPrivMsgs_Template} = "$Global{Template_Dir}/MyPrivMsgs.html";
	$Global{PrivMsg_Template} = "$Global{Template_Dir}/PrivMsg.html";
	$Global{PreviewPrivMsg_Template} = "$Global{Template_Dir}/PreviewPrivMsgForm.html";
	$Global{PrintPrivMsg_Template} = "$Global{Template_Dir}/PrintPrivMsg.html";

	$Global{ViewPrivMsgInbox_Template} = "$Global{Template_Dir}/ViewPrivMsgInbox.html";
	$Global{ViewPrivMsgOutbox_Template} = "$Global{Template_Dir}/ViewPrivMsgOutbox.html";
	$Global{ViewPrivMsgSentbox_Template} = "$Global{Template_Dir}/ViewPrivMsgSentbox.html";
	$Global{ViewPrivMsgSavedbox_Template} = "$Global{Template_Dir}/ViewPrivMsgSavedbox.html";
	$Global{ViewPrivMsgDraftsbox_Template} = "$Global{Template_Dir}/ViewPrivMsgDraftsbox.html";

	$Global{MyPrivMsgsInbox_Template} = "$Global{Template_Dir}/MyPrivMsgsInbox.html";
	$Global{MyPrivMsgsOutbox_Template} = "$Global{Template_Dir}/MyPrivMsgsOutbox.html";
	$Global{MyPrivMsgsSentbox_Template} = "$Global{Template_Dir}/MyPrivMsgsSentbox.html";
	$Global{MyPrivMsgsSavedbox_Template} = "$Global{Template_Dir}/MyPrivMsgsSavedbox.html";
	$Global{MyPrivMsgsDraftsbox_Template} = "$Global{Template_Dir}/MyPrivMsgsDraftsbox.html";
	#------------------------------------------------------
	$Global{BlockList_Template} = "$Global{Template_Dir}/BlockList.html";

	$Global{Mail_Lists_Template} = "$Global{Template_Dir}/MailLists.html";
	$Global{Advertise_Template} = "$Global{Template_Dir}/Advertise.html";
	$Global{Search_Template} = "$Global{Template_Dir}/Search.html";

	$Global{Copyright_Template} = "$Global{Template_Dir}/Copyright.html";
	$Global{Terms_of_Use_Template} = "$Global{Template_Dir}/TermsOfUse.html";
	$Global{Privacy_Policy_Template} = "$Global{Template_Dir}/PrivacyPolicy.html";

	$Global{Help_Template} = "$Global{Template_Dir}/Help.html";
	$Global{About_Us_Template} = "$Global{Template_Dir}/AboutUs.html";
	$Global{Set_Language_Template} = "$Global{Template_Dir}/SetLanguage.html";

	$Global{Search_Tips_Template} = "$Global{Template_Dir}/SearchTips.html";
	$Global{General_Template} = "$Global{Template_Dir}/General.html";
	$Global{Contact_Us_Template} = "$Global{Template_Dir}/ContactUs.html";

	$Global{Forgot_User_ID_Template} = "$Global{Template_Dir}/ForgotUserID.html";
	$Global{Forgot_Password_Template} = "$Global{Template_Dir}/ForgotPassword.html";

	$Global{AdvancedSearch_Template} = "$Global{Template_Dir}/AdvancedSearch.html";

	$Global{Banner_Login_Template} = "$Global{Template_Dir}/BannerLogin.html";
	$Global{Banner_Stats_Template} = "$Global{Template_Dir}/BannerStats.html";
	$Global{Banner_Template} = "$Global{Template_Dir}/Banner.html";

	$Global{Community_Template} = "$Global{Template_Dir}/Community.html";
}
#==========================================================
sub Help_Link{
my ($Subject, $URL)=@_;
my ($Out, $Sub, $Width, $Height);

	$Width = $Global{Admin_Help_Window_Width};
	$Height = $Global{Admin_Help_Window_Height};
	$Sub = $Subject;
	$Sub =~ s/\_/ /g;
	
	$Global{Help_URL} = "http://www.boardawy.com/Help";
	$Out = qq|<a href="#" onClick="window.open('$Global{Help_URL}/$Subject\.html','Mewsoft_Software_Help','WIDTH=$Width,HEIGHT=$Height,  toolbar=yes, directories=yes,menubar=yes, scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');return false;"  ONMOUSEOVER="window.status=\'Help: $Sub\'; return true;" ONMOUSEOUT=" window.status=\'\'; return true;">What\'s This?</a>|;
	return $Out;
}
#==========================================================
sub Help_Link_HREF{
my ($Subject)=@_;
my ($Out, $Sub, $Width, $Height);
	
	$Width = $Global{Admin_Help_Window_Width};
	$Height = $Global{Admin_Help_Window_Height};
	$Sub = $Subject;
	$Sub =~ s/\_/ /g;
	$Global{Help_URL} = "http://www.boardawy.com/Help";
#onClick="window.open('$Global{Help_URL}/$Subject\.html','Mewsoft_Software_Help','WIDTH=$Width,HEIGHT=$Height,scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');return false;"  ONMOUSEOVER="window.status='Help: $Sub'; return true;" ONMOUSEOUT=" window.status=''; return true;"
	$Out = qq|onClick="window.open('$Global{Help_URL}/$Subject\.html','Mewsoft_Software_Help','WIDTH=$Width,HEIGHT=$Height, toolbar=yes, directories=yes,menubar=yes, scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');return false;"  ONMOUSEOVER="window.status='Help: $Sub'; return true;" ONMOUSEOUT=" window.status=''; return true;"|;
	return $Out;
}
#==========================================================
sub InitializeThemePaths{
my (@Langs, @Themes, $Line, $Lang, $Theme, %Themes);

	$Global{Default_Language} = $Global{Language};
	
	if ($Cookies{User_Language}) {
			$Global{Language} = $Cookies{User_Language};
			if (!-d "$Global{Data_Dir}/language/$Global{Language}") {
					&Delete_Cookies("User_Language");
					$Global{Language} = $Global{Default_Language};
			}
	}
	elsif ($Param{Lang}) {
		$Global{Language} = $Param{Lang};
	}
	else{
		$Global{Language} ||= "English";
	}

	if (!-d "$Global{Data_Dir}/language/$Global{Language}") {
			&Delete_Cookies("User_Language");
			$Global{Language} = $Global{Default_Language};
			@Langs = &LanguagesList;
			$Global{Language} = $Lang[0];
	}
	
	#$Global{Themes} = "English:Default|Arabic:demo"; # comment this line

	@Themes = split (/\|/, $Global{Themes});
	foreach $Line (@Themes) {
			($Lang, $Theme) = split(/\:/, $Line);
			$Themes{$Lang} = $Theme;
	}
	$Global{Theme} = $Themes{$Global{Language}};

	if (!-d "$Global{Data_Dir}/templates/$Global{Theme}") {
			@Themes = &ThemesList;
			$Global{Theme} = $Themes[0];
	}
	
}
#==========================================================
sub InitializeTheme{
my (%Custom, $K, $V);

	%Custom = &ReadThemeConfig;
	while (($K, $V) = each %Custom) {
			$Plugins{$K} = &Translate($V);
			$Global{$K} = $V;
	}
}
#==========================================================
sub Read_Configuration{

	$Global{Data_Dir} = "$Global{CGI_Dir}/data";
	$Global{Configuration_File} = "$Global{Data_Dir}/SysConfig.pm";
	$Global{Data_File} = "$Global{Data_Dir}/SysData.pm";
	$Global{Lock_Dir} = "$Global{Data_Dir}/lock";
	#----------------------------------------------------------
	&Read_Configuration_Files;
	#----------------------------------------------------------
	 # Comment this line
	#use defaults; &Default_Parameters; &Get_General_Classes; &Get_Banner_Defaults; # Comment this line
	#----------------------------------------------------------
	$Global{Software_Version} = "2.02";
	$Global{Software_Build} = "082105";
	#----------------------------------------------------------
	&InitializeThemePaths;
	&InitializeLanguagePaths;
	#----------------------------------------------------------
	$Global{Templates_Dir} = "$Global{Data_Dir}/templates";
	$Global{Template_Dir} = "$Global{Templates_Dir}/$Global{Theme}";
	$Global{ThemeConfigFile} = "$Global{Template_Dir}/Config.pm";
	#----------------------------------------------------------
	&InitializeTheme; #Read theme classes
	#----------------------------------------------------------
	#&Get_General_Classes; # comment this line
	#while (($K, $V) = each %Plugins) {$Plugins{$K} = &Translate($Global{$K});} # comment this line. Load default classes
	#----------------------------------------------------------
	&InitializeTemplatesPaths;
	#----------------------------------------------------------
	# Directories and URLs
	$Global{Custom_Dir} = "$Global{Data_Dir}/lib";
	$Global{Mail_Lists_Dir} = "$Global{Data_Dir}/mail";
	$Global{Database_Dir} = "$Global{Data_Dir}/database";
	$Global{Temp_Dir} = "$Global{Data_Dir}/temp";
	$Global{Images_URL} = "$Global{HTML_URL}/images";
	$Global{Upload_Dir} = "$Global{HTML_Dir}/upload";
	$Global{Upload_URL} = "$Global{HTML_URL}/upload";
	$Global{Avatars_Dir} = "$Global{HTML_Dir}/avatars";
	$Global{Avatars_URL} = "$Global{HTML_URL}/avatars";

	$Global{Theme_Images_URL} = "$Global{HTML_URL}/theme/$Global{Theme}";
	#----------------------------------------------------------
	# Data files
	$Global{Banned_Words_File} = "$Global{Data_Dir}/BannedWords.txt";
	$Global{RegisterOptions_File} = "$Global{Data_Dir}/RegisterOptions.pm";
	$Global{Promotional_Code_File} = "$Global{Data_Dir}/PromotionalCodes.txt";
	$Global{BannedEmail_File} = "$Global{Data_Dir}/BannedEmails.pm";
	$Global{Mail_Letters_File} = "$Global{Mail_Lists_Dir}/letters.pm";
	$Global{Visitors_Log_File}="$Global{Data_Dir}/logs/forum.log";
	#---------------------------------------------------------------------------------------
	$Global{Banner_Impressions_Bar} = "$Global{Images_URL}/imprbar.gif";
	$Global{Banner_Clicks_Bar} = "$Global{Images_URL}/clickbar.gif";
	#---------------------------------------------------------------------------------------
	$Global{Prog_URL} = "$Global{CGI_URL}/$Global{Main_Prog}";
	$Global{Admin_URL} = "$Global{CGI_URL}/$Global{Admin_Prog}";
	$Global{Ads_Click_URL} = "$Global{CGI_URL}/$Global{Banner_Click_Prog}";
	$Global{Ads_URL} = "$Global{CGI_URL}/$Global{Banner_Ads_Prog}";
	#---------------------------------------------------------------------------------------
	#$Global{Update_URL} = "http://www.mewsoft.com/cgi-bin/update/update.cgi";
	$Global{Update_URL} = "http://www.boardawy.com/cgi-bin/installer/installer.cgi";
	#---------------------------------------------------------------------------------------
	&Log_Visitor;
	#---------------------------------------------------------------------------------------
}
#==========================================================
#==========================================================
sub Log_Visitor{
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
my ($LOG, $Query);

    $Query = "";
	if ($ENV{CONTENT_LENGTH} ) {
				read(STDIN, $Query, $ENV{CONTENT_LENGTH});
    } 
	elsif ($ENV{QUERY_STRING}) {
			$Query = $ENV{QUERY_STRING};
    }

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$mon++;
	$year += 1900;
	
	$LOG = qq!$mday/$mon/$year/$hour:$min:$sec|$ENV{REMOTE_ADDR}|$Script_URL?$Query|$ENV{HTTP_REFERER}!;
	
	&Lock("$Global{Visitors_Log_File}");
	open(LOG, ">>$Global{Visitors_Log_File}");
	print LOG "$LOG\n";
	close(LOG);
	&Unlock("$Global{Visitors_Log_File}");
}
#==========================================================
1;
