=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Classifiedawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	File Version         : 6.00
	Copyrights  2004-2005 Mewsoft Corporation. All rights reserved.
==========================================================
=cut
#==========================================================
sub PrivMsgsOptions{
my ($Message) = @_;
my ($Help, $Out);

	$Help = &Help_Link("PrivMsgs_Options");
	$Out = &PrivMsgsOptionsForm($Message);
	&Print_Page($Out, "Private Messages Options", $Help);
}
#==========================================================
sub PrivMsgsOptionsForm{
my ($Message) = @_;
my (%HTM, $Out, $Sig_Treat_HTML, $Avatar_Allow_File_Upload);

	# Private messaging
	$Global{PM_Treat_HTML} = "Show_HTML";
	$Global{PM_Max_Title_Length} = 80;
	$Global{PM_Max_Len} = 100000;
	$Global{PM_Max_To} = 3;

	$Global{Messages_Per_Page} = 10;
	$Global{PM_ListDateFormat} = qq!MON-MD-YY HH:MM AP!;
	$Global{PM_MsgDateFormat} = qq!MON-MD-YY HH:MM AP!;
	
	$Global{PM_Allow_File_Upload} = 1;
	$Global{PM_Upload_Any_File}  = 0;
	$Global{PM_Max_Upload_Files} = 15;
	$Global{PM_Max_Upload_File_Size} = 2048; #in KB
	$Global{PM_Max_Upload_Size} = 8192;
	$Global{PM_Files_Ext_Allowed} = "jpg gif png doc csv txt pdf wav mid mov avi exe cgi php pl cpp c zip gz tar";

	$Global{PrivMsg_Notify_Email} = "Webmaster <webmaster\@mewsoft.com>";

	$Global{PM_Max_Inbox} = 100;
	$Global{PM_Max_Sentbox} = 100;
	$Global{PM_Max_Savedbox} = 100;
	$Global{PM_Max_Draftsbox} = 50;
	#----------------------------------------------------------
	#----------------------------------------------------------------
	%HTM = (
			Show_Code => "Disable All HTML",
			Show_Safe_Code => "Allow Safe HTML",
			Remove_Code => "Remove All HTML",
			Show_HTML => "Allow All HTML"
		);
	
	$PM_Treat_HTML = "";
	foreach $Key  (sort keys %HTM) {
				$Selected = "";
				if ($Key eq $Global{PM_Treat_HTML}) {$Selected = "selected";}
				$PM_Treat_HTML .= qq!<option value="$Key" $Selected>$HTM{$Key}</option>!;
	}
	#----------------------------------------------------------------
	#----------------------------------------------------------------
	$PM_Status = &OptionYesNo($Global{PM_Status});
	$PM_Allow_File_Upload = &OptionYesNo($Global{PM_Allow_File_Upload});
	$PM_Upload_Any_File = &OptionYesNo($Global{PM_Upload_Any_File});
	#----------------------------------------------------------------

$Out=<<HTML;
<p align="center"><font color="red" size="3"><b>$Message</b></font></p>

<FORM METHOD="POST" ACTION="$Script_URL">
  <INPUT TYPE="hidden" NAME="action" VALUE="SavePrivMsgsOptions">
  <TABLE BORDER="01" WIDTH="100%" CELLSPACING="0" CELLPADDING="2" $Global{Admin_Table_Attr}>
    <tr><td>Enable Private Messags System:</td><td><select size="1" name="PM_Status">$PM_Status</select></td></tr>

    <tr><td>Messages HTML Manipulation:</td><td><select size="1" name="PM_Treat_HTML">$PM_Treat_HTML</select></td></tr>
	<tr><td>Title Maximum Size:</td><td><input type="text" name="PM_Max_Title_Length" size="10" value="$Global{PM_Max_Title_Length}"> Bytes</td></tr>
	<tr><td>Message Maximum Size:</td><td><input type="text" name="PM_Max_Len" size="10" value="$Global{PM_Max_Len}"> Bytes</td></tr>
	<tr><td>Maximum TO Users:</td><td><input type="text" name="PM_Max_To" size="10" value="$Global{PM_Max_To}"> </td></tr>
	<tr><td>Default Messages Per Page:</td><td><input type="text" name="Messages_Per_Page" size="10" value="$Global{Messages_Per_Page}"> </td></tr>

	<tr><td>Maximum Inbox Messages:</td><td><input type="text" name="PM_Max_Inbox" size="10" value="$Global{PM_Max_Inbox}"> </td></tr>
	<tr><td>Maximum Sentbox Messages:</td><td><input type="text" name="PM_Max_Sentbox" size="10" value="$Global{PM_Max_Sentbox}"> </td></tr>
	<tr><td>Maximum Saved Messages:</td><td><input type="text" name="PM_Max_Savedbox" size="10" value="$Global{PM_Max_Savedbox}"> </td></tr>
	<tr><td>Maximum Drafts Messages:</td><td><input type="text" name="PM_Max_Draftsbox" size="10" value="$Global{PM_Max_Draftsbox}"> </td></tr>

    <tr><td valign="top">Listing Date Format:</td><td><input type="text" name="PM_ListDateFormat" size="65" value="$Global{PM_ListDateFormat}">
		<br><b>HR:</b> Hour 0-23 - <b>HH:</b> Hour 1-12 - <b>MM:</b> Minute 0-59 - <b>SS:</b> Second 0-59 - <b>AP:</b> AM/PM<br><b>MON:</b> Month 1-12 - <b>MD:</b> Day 1-31- <b>WD:</b> Weekday - <b>MONTH:</b> Month Name- <b>YY</b>: Year  - <b>YYYY</b>: Year
	</td></tr>

    <tr><td valign="top">Message Date Format:</td><td><input type="text" name="PM_MsgDateFormat" size="65" value="$Global{PM_MsgDateFormat}">
		<br><b>HR:</b> Hour 0-23 - <b>HH:</b> Hour 1-12 - <b>MM:</b> Minute 0-59 - <b>SS:</b> Second 0-59 - <b>AP:</b> AM/PM<br><b>MON:</b> Month 1-12 - <b>MD:</b> Day 1-31- <b>WD:</b> Weekday - <b>MONTH:</b> Month Name- <b>YY</b>: Year  - <b>YYYY</b>: Year
	</td></tr>

	<tr><td>Allow Users to Attach Files</td><td><select size="1" name="PM_Allow_File_Upload">$PM_Allow_File_Upload</select></td></tr>
	<tr><td>Maximum Number of Files Allowed to Attach:</td><td><input type="text" name="PM_Max_Upload_Files" size="10" value="$Global{PM_Max_Upload_Files}"></td></tr>
	<tr><td>Maximum Attached File Size (Per File):</td><td><input type="text" name="PM_Max_Upload_File_Size" size="10" value="$Global{PM_Max_Upload_File_Size}"> KB</td></tr>
	<tr><td>Maximum Attached Combined Total Files Size</td><td><input type="text" name="PM_Max_Upload_Size" size="10" value="$Global{PM_Max_Upload_Size}"> KB</td></tr>
	<tr><td>Allow any File Type to Attach:</td><td><select size="1" name="PM_Upload_Any_File">$PM_Upload_Any_File</select></td></tr>
	<tr><td valign="top">Files Extensions Allowed: <br>Separate by a Space</td><td><textarea name="PM_Files_Ext_Allowed" rows="5" cols="55">$Global{PM_Files_Ext_Allowed}</textarea></td></tr>


</table>
<br>

<div align="center"><center>
  <table border="0" width="100%" cellspacing="0" cellpadding="5">
      <tr><td nowrap align="center">
			<input type="submit" value="Save Changes" name="submit" style="color: #000080; border-style: ridge">&nbsp;&nbsp;
			  <input type="reset" value="Reset" name="Reset" style="color: #000080; border-style: ridge">&nbsp; 
	  </td>
      </tr>
  </table>
  </center>
</div>
</form>
HTML

	return $Out;
}
#==========================================================
sub SavePrivMsgsOptions{
my (%Config, $Key);

	undef %Config;

	$Config{PM_Status} = $Param{PM_Status};
	$Config{PM_Treat_HTML} = $Param{PM_Treat_HTML};
	$Config{PM_Max_Title_Length} = $Param{PM_Max_Title_Length};
	$Config{PM_Max_Len} = $Param{PM_Max_Len};
	$Config{PM_Max_To} = $Param{PM_Max_To};
	$Config{Messages_Per_Page} = $Param{Messages_Per_Page};
	$Config{PM_ListDateFormat} = $Param{PM_ListDateFormat};
	$Config{PM_MsgDateFormat} = $Param{PM_MsgDateFormat};
	$Config{PM_Allow_File_Upload} = $Param{PM_Allow_File_Upload};
	$Config{PM_Upload_Any_File} = $Param{PM_Upload_Any_File};
	$Config{PM_Max_Upload_Files} = $Param{PM_Max_Upload_Files};
	$Config{PM_Max_Upload_File_Size} = $Param{PM_Max_Upload_File_Size};
	$Config{PM_Max_Upload_Size} = $Param{PM_Max_Upload_Size};

	$Param{PM_Files_Ext_Allowed} =~ s/\cM|\n|\r//g;
	$Config{PM_Files_Ext_Allowed} = $Param{PM_Files_Ext_Allowed};

	$Config{PrivMsg_Notify_Email} = $Param{PrivMsg_Notify_Email};

	$Config{PM_Max_Inbox} = $Param{PM_Max_Inbox};
	$Config{PM_Max_Sentbox} = $Param{PM_Max_Sentbox};
	$Config{PM_Max_Savedbox} = $Param{PM_Max_Savedbox};
	$Config{PM_Max_Draftsbox} = $Param{PM_Max_Draftsbox};
	#----------------------------------------------------------
	&Update_Configuration(%Config);

	foreach $Key (keys %Config) {
			$Global{$Key} = $Config{$Key};
	}

	&PrivMsgsOptions("Private Messages Options Successfully Saved");
}
#==========================================================

1;