=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Update_System_Statistics{
my($Total_Links, 	$Categories_Count);
my(%Config);

	&Update_Total_Accounts_Counts;
	&Update_Accounts_Counts;
	&System_Statistics();
}
#==========================================================
sub System_Statistics{
my ($Out);
my($Help);

	$Help = &Help_Link("index");
	
	&LoadForumsConfig;

$Out=<<HTML;
<table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse" width="100%">
  <tr>
    <td width="100%"><a href="$Script_URL?action=Update_System_Statistics">Update System Statistics</a></td>
  </tr>
</table>
<br>

<table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse" width="100%">
  <tr>
    <td width="100%"><b><font size="3">Accounts</font></b></td>
  </tr>
  <tr>
    <td width="100%">

    <table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse">
      <tr><td nowrap>Total: $Global{TotalUsers} &nbsp; Active: $Global{TotalActiveUsers} &nbsp; Suspended: $Global{TotalInactiveUsers}</td></tr>
		<tr>
			<td nowrap>Registration History   <a href="$Script_URL?action=New_Users_History&Period=7">1 Week</a>
			&nbsp;&nbsp;<a href="$Script_URL?action=New_Users_History&Period=31">1 Month</a>
			&nbsp;&nbsp;<a href="$Script_URL?action=New_Users_History&Period=186">6 Months</a>
			&nbsp;&nbsp;<a href="$Script_URL?action=New_Users_History&Period=365">1 Year</a>
			&nbsp;&nbsp;<a href="$Script_URL?action=New_Users_History&Period=1095">3 Years</a>
			&nbsp;&nbsp;<a href="$Script_URL?action=New_Users_History&Period=1825">5 Years</a>
			&nbsp;&nbsp;<a href="$Script_URL?action=New_Users_History&Period=0">All</a>
			</td>
		</tr>
    </table>

	</td>
</tr>
</table>

HTML

	&Print_Page($Out, "System Statistics", $Help);

}
#==========================================================
sub New_Users_History{
my($Out, %Users, %User, @Keys);
my ($User_ID, $Key, $MaxCount, $Count, $Date, $Width);
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst);

	undef %Users;
	undef %User;

	$Param{Period} ||= 0;
	if ($Param{Period} > 0) {
		$Start = &Time(time) - ($Param{Period}*24*60*60);
		$End = &Time(time);
	}
	else {
			$Start = 0; $End = 0;
	}
	
	%Users = &Users_History_Count($Start, $End);

	while (($User_ID, $Date) = each %Users) {
			($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst ) = gmtime($Date);
			$year += 1900;
			$mon++;
			$mday = sprintf("%02d", $mday);
			$mon = sprintf("%02d", $mon);
			$Key = "$mon-$mday-$year";
			$User{$Key}++;
	}

	$Count = 0;
	@Keys = reverse sort keys %User;

	$MaxCount = 0; $Total = 0;
	foreach $Date(@Keys) {
		$Total += $User{$Date};
		if ($User{$Date} > $MaxCount) {$MaxCount = $User{$Date};}
	}

$Out =<<HTML;
<p><b>User Registration Daily Statistics</b></p>
$Total Users registered during this time period.<br><br>
<table border="1" cellpadding="2" cellspacing="0" style="border-collapse: collapse" bordercolor="#F7F7F7" width="100%">
<tr>
<td bgcolor="#E1E1E1" align="center" nowrap><b>#</b></td>
<td bgcolor="#E1E1E1" align="center" nowrap><b>Date</b></td>
<td bgcolor="#E1E1E1" align="center" nowrap><b>Count</b></td>
<td bgcolor="#E1E1E1" width="100%" align="center"><b>Graph</b></td>
</tr>
HTML

	foreach $Date(@Keys) {
		$Count++;
		$Width = ($User{$Date} / $MaxCount)*500;
		$Out .= qq!<tr><td bgcolor="#F0F0F0" nowrap align="right">&nbsp;$Count&nbsp;</td><td nowrap>&nbsp;$Date&nbsp;</td><td nowrap>&nbsp;<font color="green">$User{$Date}</font></td><td width="100%" align="left" nowrap>&nbsp;<img src="$Global{Images_URL}/bar5x5.jpg" width="$Width" height="5" border="0"></td></tr>!;
	}

	$Out .= "</table>";

	&Print_Page($Out, "Auction System Statistics", $Help);

}
#==========================================================
1;