=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	File Version         : 1.00
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub DeleteTopic{
my (%Forum, %Topic, @Posts, $Posts, %Message, $Template);
my ($Temp, $TimeClass, $TimeFormat);

	$Plugins{Bar_Action} = $Language{bar_delete_topic};

	%Forum = &GetForum($Param{Forum});
	%Topic = &GetForumTopic($Param{Topic});

	@Posts = &GetForumTopicPosts($Param{Topic});
	$Posts = @Posts;

	if (@Posts) {
			%Message = &GetForumMessage($Posts[0]);
	}
	#------------------------------------------------------
	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{General_Template});
				return;
	}
	#------------------------------------------------------
	$Template = &Translate_File($Global{ForumDeleteTopic_Template});
	$Template =~ s/<!--Action-->/$Script_URL/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Topic{Forum}/g;
	$Template =~ s/<!--Topic-->/$Topic{Topic}/g;
	$Template =~ s/<!--Post-->/$Param{Post}/g;
	$Template =~ s/<!--Author-->/$Topic{Author}/g;
	$Template =~ s/<!--Posts-->/$Posts/g;
	
	$Temp = qq!$Script_URL?action=ViewProfile&Author=$Topic{Author}&Lang=$Global{Language}!;
	$Template =~ s/<!--AuthorLink-->/$Temp/g;
	#------------------------------------------------------
	$Temp = qq!$Script_URL?action=TopicReview&Topic=$Param{Topic}&Page=1&Lang=$Global{Language}!;
	$Template =~ s/<!--TopicReviewLink-->/$Temp/g;
	#------------------------------------------------------
	$TimeClass = ""; $TimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Template =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
				$TimeClass = $1 . $2 . $3. $4. $5;
				$TimeFormat =  $4;
	}
	$TimeClass =~ s/\(/\\\(/g;
	$TimeClass =~ s/\)/\\\)/g;

	if ($Topic{Time} > 0) {
			$Temp = &ParseDate($TimeFormat, $Topic{Time});
	}
	else{	
			$Temp = "";
	}
	$Template =~ s/$TimeClass/$Temp/g;
	#------------------------------------------------------
	$Template =~ s/<!--Subject-->/$Message{Subject}/g;
	
	$Temp = $Message{Message};
	$Temp =~ s/\\\n/\n/g;
	$Temp =~ s/[\>]\s*\n/\> /g;
	$Temp =~ s/\n/\<br\>/g;
	$Template =~ s/<!--Message-->/$Temp/g;

	&Display($Template, 1);
}
#==========================================================
sub ProcessDeleteTopic{
my (%Topic, $Posts, $Topics, $Query);

	%Topic = &GetForumTopic($Param{Topic});
	$Param{Topic} = $Topic{Topic};
	$Param{Forum} = $Topic{Forum};

	if ($Param{CancelDelete}) {
			&ViewTopic;
			return;
	}

	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Topic{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{General_Template});
				return;
	}

	&DeleteForumTopic($Param{Topic});
	#------------------------------------------------------
	$Post = &GetForumLastPost($Topic{Forum});
	#------------------------------------------------------
	$Query = qq!UPDATE Forum_Forums SET LastPost=$Post WHERE Forum=$Topic{Forum}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	&UpdateForumsCounts;
	#------------------------------------------------------
	&Forums;

}
#==========================================================
sub MoveTopic{
	&ViewTopic;
}
#==========================================================
sub CopyTopic{
	&ViewTopic;
}
#==========================================================
sub StatusTopic{
my (%Topic, $Query, $sth, $Status, $Temp);

	%Topic = &GetForumTopic($Param{Topic});
	#%Forum = &GetForum($Topic{Forum});
	#------------------------------------------------------
	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{General_Template});
				return;
	}
	#------------------------------------------------------
	$Query = qq!SELECT Status FROM Forum_Topics WHERE Topic=$Param{Topic}!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Status = 0;
	while(($Temp) = $sth->fetchrow_array) {$Status = $Temp; last;}
	$sth->finish;
	$Status = !$Status;

	$Status ||= 0;
	$Query = qq!UPDATE  Forum_Topics SET Status=$Status WHERE Topic=$Param{Topic}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	&ViewTopic;
}
#==========================================================
sub EmailTopic{

	&ViewTopic;
}
#==========================================================
sub PrintTopic{
	&ViewTopic;
}
#==========================================================
sub DownloadTopic{
}
#==========================================================
sub WatchTopic{
my ($User, $Query, $sth, $Temp, $Found);

	&Check_Account_Login;
	#------------------------------------------------------
	$User = $dbh->quote($Param{User_ID});
	$Query = qq!SELECT User FROM Forum_Watching WHERE Topic=$Param{Topic} AND User=$User!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while(($Temp) = $sth->fetchrow_array) {$Found = 1; last;}
	$sth->finish;

	if ($Found) {
				$Query = qq!DELETE FROM Forum_Watching WHERE User=$User AND Topic=$Param{Topic}!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	else{
				$Query = qq!INSERT INTO  Forum_Watching SET User=$User, Topic=$Param{Topic}!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	&ViewTopic;
}
#==========================================================
sub NotifyTopic{
my ($User, $Query, $sth, $Temp, $Found);

	&Check_Account_Login;
	#------------------------------------------------------
	$User = $dbh->quote($Param{User_ID});
	$Query = qq!SELECT User FROM Forum_Topic_Notify WHERE Topic=$Param{Topic} AND User=$User!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while(($Temp) = $sth->fetchrow_array) {$Found = 1; last;}
	$sth->finish;

	if ($Found) {
				$Query = qq!DELETE FROM Forum_Topic_Notify WHERE User=$User AND Topic=$Param{Topic}!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	else{
				$Query = qq!INSERT INTO  Forum_Topic_Notify SET User=$User, Topic=$Param{Topic}, Status=0!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	&ViewTopic;
}
#==========================================================

1;